angular.module('archiveSummaryWidgetModule',['dynamicdashboardapp','ui.dashboard','dynamicDashboardUtilityModule'])
.controller('ArchiveSummaryWidgetContorller', function ($scope, $timeout){
    
    $scope.varwidth=0;
    
    /* getWidth function to resize chart when resize widget. */
    $scope.getWidth=function(){   
        var width_resized=$("#archivechart").width();
        $("#archivechart").empty();
        $("#archivechart_bar").empty();
        
        var r_resized=Raphael('archivechart',"100%","100%");  
        raph=Raphael('archivechart_bar',"100%","100%");
        plotBarGraph(raph, width_resized-50, [55, 20, 13, 32, 5, 1, 2, 10], [10, 2, 1, 5, 32, 13, 20, 55]);   
        plotLineGraph(r_resized,width_resized,yAixsValues,yAixsValues1);
    }

    var endDate=new Date();
    var startDate=new Date(endDate.getTime() - 7 * 24 * 60 * 60 * 1000); 

    /* JSON response to plot chart */
    var jsonResponse=[
      {       
           "day": "11/01/2014",
            "load": 0.4,
            "load1": 3.4,    
            "time": "12:15:00 AM"
      },
      {
            "day": "11/01/2014",
            "load": 4.0,
           "load1": 2.4, 
            "time": "12:30:00 AM"
      },
      {
            "day": "11/01/2014",
            "load": 0.6192944811,
            "load1":4.4, 
            "time": "12:45:00 AM"
      },
      {
            "day": "11/01/2014",
            "load": 0.60473254576,
            "load1": 2.4, 
            "time": "01:00:00 AM"
      },
      {
            "day": "11/01/2014",
            "load": 0.59797185436,
            "load1":6.4, 
            "time": "01:15:00 AM"
      },
      {
            "day": "11/01/2014",
            "load": 0.57137367483,
            "load1": 2.4, 
            "time": "01:30:00 AM"
      },
      {
            "day": "11/01/2014",
            "load": 4.55407756024,
            "load1": 2.4, 
            "time": "01:45:00 AM"
    }]

    /* x-axis and y-axis array for chart */
    var xAxisValues=[];
    var yAixsValues=[];
    var yAixsValues1=[];
    
    $("#archivechart").css("display" ,"block");
    $("#archivechart_bar").css("display" ,"none");
    
    /* parse JSON data for chart */
    for (var i=0 ; i <jsonResponse.length ; i++){
        var dateInMili= jsonResponse[i].day +" " + jsonResponse[i].time;
        var d=new Date(dateInMili);
        yAixsValues.push(jsonResponse[i].load);
        yAixsValues1.push(jsonResponse[i].load1);
    }

    var r=Raphael('archivechart',"100%","100%");
    var c=0;
    var width_default=$("#archivechart").width();

   
    
    txtattr={ font: "12px sans-serif" };

    raph_default=Raphael('archivechart_bar',"100%","100%");

    plotBarGraph(raph_default, width_default-50, [55, 20, 13, 32, 5, 1, 2, 10], [10, 2, 1, 5, 32, 13, 20, 55]);        


    /* draw line graph when widget initialize */
    plotLineGraph(r,width_default,yAixsValues,yAixsValues1);

    /* Event listener for widgetResized event */
    $scope.$on('widgetResized', function (event, size){
     $scope.getWidth();
    });

    /* function to show line chart while selecting line chart */
    $scope.showLine =function(){
        $("#archivechart").css("display" ,"block");
        $("#archivechart_bar").css("display" ,"none");
    }

    /* function to show bar chart while selecting bar chart */
    $scope.showBar =function(){
        $("#archivechart").css("display" ,"none");
        $("#archivechart_bar").css("display" ,"block");
    }

    /* Click Event Listener for open configure model dialog box  */
    $scope.modalShown=false;
    $scope.toggleModal=function(){
        $scope.modalShown=!$scope.modalShown;
    };

    /* Event listener for dialogopenEvent */
    $scope.$on('dialogopenEvent', function (event, widget){
        if(widget.name === 'Archive Summary'){
            $scope.toggleModal();
        }
    });

    /* Event listener for leaving the widget */
    $scope.$on('leaveWidget', function (event, widget,index){
        if(widget.name === 'Archive Summary'){
            if ($scope.modalShown) {
                $scope.modalShown = false;
                $timeout(function() {
                    $scope.$digest();
                });
            }
        }
    });
})
