/* Backup Widget Contorller */
angular.module('backupSummaryWidgetModule',['dynamicdashboardapp','ui.dashboard'])
.controller('BackupWidgetContorller', function ($scope,$rootScope, $http, $location, $timeout, gettextCatalog){

        $scope.refreshKey="dash_backup_refresh";
        $scope.widgetName="Backup";
		$scope.backupErrors = 0;
		$scope.backupNotProtected = 0;
		$scope.backupProtected = 0;
	    $scope.backupTimer=3000;
        $scope.dropdownvalue="0";
    // Initialize graph values.
		$scope.BACKUP_GRAPH_VALUES = [];
		$scope.BACKUP_GRAPH_TOOLTIPS = [];
	    $scope.avgSpeed = 0;
		$scope.totalSize = 0;
		BACKUP_GRAPH_ID = [];
		Date_Range=[];
		var colorArray_avgSpeed =["rgb(40,155,212)"];
		var colorArray =["rgb(40,155,212)","rgb(139,186,84)","rgb(22,66,95)"];
	    var legend_avgSpeed=[gettextCatalog.getString("Backups")];
	    var legends=[
	        gettextCatalog.getString("Read"),
            gettextCatalog.getString("Write"),
            gettextCatalog.getString("Dedup")
        ];
		var checkForNonZero_avgSpeed = 0;
		var checkForNonZero_totalSize;
		var checkForNonZero_avgSpeed2;
		var avgSpeed2; 
		var totalSize;
        firstValue=[];
        lastValue=[];
		$scope.BACKUP_GRAPH2_VALUES =  [ [], [], [] ];
		$scope.BACKUP_GRAPH2_TOOLTIPS = [];
		$scope.reSizeGraph=true;
		
		
		$scope.BACKUP_GRAPH3_VALUES =  [ [], [], [] ];
		$scope.BACKUP_GRAPH3_TOOLTIPS = [ ];
	
    /* Click Event Listener for open configure model dialog box  */
    $scope.modalShown=false;
    $scope.toggleModal=function(){
	        $scope.modalShown=!$scope.modalShown;
    };

    /* Event listener for dialogopenEvent */
    $scope.$on('dialogopenEvent', function (event, widget,index){
        if(widget.name === 'BACKUP SUMMARY'){
            $scope.toggleModal();
			$('#id_backupRefresh').val($rootScope.listOfTimer[0]/1000);
			event.defaultPrevented = true;
        }
    });
	
	/* Event listener for manual;Refesh */
	$scope.$on('manualRefreshEvent', function (event, widget,index){
     if(widget.name === 'BACKUP SUMMARY'){
		$rootScope.getBackupRefereshData();
		event.defaultPrevented = true;
		    
        }
    });

	/* Event listener for drilldown to protect status */
	$scope.$on('drilldownEvent', function (event, widget, index){
		if(widget.name === 'BACKUP SUMMARY' ||
			widget.name === 'BACKUP COPY - HOT TARGETS' ||
			widget.name === 'BACKUP COPY - COLD TARGETS'){
			$scope.runReport(22, 6);
		}
	});

    /* Event listener for leaving the widget */
    $scope.$on('leaveWidget', function (event, widget,index){
        if(widget.name === 'BACKUP SUMMARY'){
            if ($scope.modalShown) {
                $scope.modalShown = false;
                $timeout(function() {
                    $scope.$digest();
                });
            }
        }
    });

    $scope.getSummary = function(token) {
        // Load summary data for graphs.
        $http({
            method: 'GET',
            url: '/api/summary/days'
        })
            .success(function(data, status, headers) {
                var results = data.data;
                var avg_speed = [];
                var weekAverageSpeed=0;
                var avg_speed_tooltips = [];

                if (results[0] !== null) {
                    var backup_speed = results[0].backup_speed;
                    if (typeof backup_speed !== 'undefined') {
                        for (var i = 0, j = 0; i < backup_speed.length; i++) {

                            var obj = backup_speed[i];
                            avg_speed[j] = obj.avg_speed;
                            /* avg_speed_tooltips[j] = avg_speed[j].toString() + ' ' + obj.units; */

                            avg_speed_tooltips[j]=obj.units;
                            // No need to do this, Date_Range is not referenced.
                            //Date_Range[j]=obj.day.substring(5,obj.day.length).replace("-","/");
                            j++;
                        }
                    }
                }

                avg_speed = [ avg_speed ];
                $scope.BACKUP_GRAPH_VALUES = avg_speed;

                $scope.BACKUP_GRAPH_TOOLTIPS = avg_speed_tooltips;
                $scope.avgSpeed = Math.max.apply(Math,$scope.BACKUP_GRAPH_VALUES[0])+ " " + $scope.BACKUP_GRAPH_TOOLTIPS[0];

                checkForNonZero_avgSpeed =Math.max.apply(Math,$scope.BACKUP_GRAPH_VALUES[0]);
                var read_size = [];
                var read_tooltips = [];
                var write_size = [];
                var write_tooltips = [];
                var compress_size = [];
                var compress_tooltips = [];
                var totalSizeforWeek=0;
                if (results[1] !== null) {
                    var backup_size = results[1].backup_size;
                    if (typeof backup_size !== 'undefined') {
                        for (var i = 0, j = 0; i < backup_size.length; i++) {
                            var obj = backup_size[i];
                            read_size[j] = obj.read;
                            write_size[j] = obj.write;
                            compress_size[j] = obj.compress;
                            totalSizeforWeek=totalSizeforWeek + obj.read + obj.write + obj.compress ;
                            // No need to do this, Date_Range is not referenced.
                            //Date_Range[7+j]=obj.day.substring(5,obj.day.length).replace("-","/");
                            /*  read_tooltips[j] = read_size[j].toString() + ' ' + obj.units; */
                            read_tooltips[j]=obj.units;
                            write_tooltips[j] = write_size[j].toString() + ' ' + obj.units;
                            compress_tooltips[j] = compress_size[j].toString() + ' ' + obj.units;
                            j++;
                        }
                    }
                }

                var maxvalue=[];

                $scope.BACKUP_GRAPH2_VALUES = [ read_size, write_size, compress_size ];
                /*  $scope.BACKUP_GRAPH2_TOOLTIPS = read_tooltips.concat(write_tooltips, compress_tooltips); */
                $scope.BACKUP_GRAPH2_TOOLTIPS=read_tooltips;
                maxvalue[0]=Math.max.apply(Math,$scope.BACKUP_GRAPH2_VALUES[0]);
                maxvalue[1]=Math.max.apply(Math,$scope.BACKUP_GRAPH2_VALUES[1]);
                maxvalue[2]=Math.max.apply(Math,$scope.BACKUP_GRAPH2_VALUES[2]);

                totalSize =Math.max.apply(Math,maxvalue)+ " " + $scope.BACKUP_GRAPH2_TOOLTIPS[0];
                checkForNonZero_totalSize = Math.max.apply(Math,maxvalue);
                $scope.BACKUP_DATE=[];
                var avgSpeed2_forWeek=0;
                var read_speed = [];
                var read_tooltips = [];
                var write_speed = [];
                var write_tooltips = [];
                var compress_speed = [];
                var compress_tooltips = [];
                if (results[2] !== null) {
                    var backup_data_speed = results[2].backup_data_speed;
                    if (typeof backup_data_speed !== 'undefined') {
                        for (var i = 0, j = 0; i < backup_data_speed.length; i++) {
                            var obj = backup_data_speed[i];
                            read_speed[j] = obj.read;
                            write_speed[j] = obj.write;
                            compress_speed[j] = obj.compress;
                            avgSpeed2_forWeek=avgSpeed2_forWeek+obj.read+obj.write+obj.compress;
                            //$scope.BACKUP_DATE[j]=obj.day.substring(5,obj.day.length).replace("-","/");
                            // Set date based on locale.
                            $scope.BACKUP_DATE[j] = dateAxisLabel(obj.day, true);
                            read_tooltips[j]=obj.units;
                            write_tooltips[j] = write_speed[j].toString() + ' ' + obj.units;
                            compress_tooltips[j] = compress_speed[j].toString() + ' ' + obj.units;
                            j++;
                        }
                    }
                }

                $scope.BACKUP_GRAPH3_VALUES = [ read_speed, write_speed, compress_speed ];
                $scope.BACKUP_GRAPH3_TOOLTIPS=  read_tooltips;

                var maxvalue2=[];
                maxvalue2[0]=Math.max.apply(Math,$scope.BACKUP_GRAPH3_VALUES[0]);
                maxvalue2[1]=Math.max.apply(Math,$scope.BACKUP_GRAPH3_VALUES[1]);
                maxvalue2[2]=Math.max.apply(Math,$scope.BACKUP_GRAPH3_VALUES[2]);

                avgSpeed2 =Math.max.apply(Math,maxvalue2) + " " + $scope.BACKUP_GRAPH3_TOOLTIPS[0];
                checkForNonZero_avgSpeed2 = Math.max.apply(Math,maxvalue2);
                $('#backupchart_avgspeed').empty();
                $('#backupchart_totalsize').empty();
                $('#backupchart_datareduction').empty();
                var avgspeed_width = $('#backupchart_avgspeed').width();
                var totalsize_width = $('#backupchart_totalsize').width();
                var datareduction_width = $('#backupchart_datareduction').width();

                plotWidgetBarGraph("#backupchart_avgspeed", $scope.BACKUP_GRAPH_VALUES, $scope.BACKUP_GRAPH_TOOLTIPS[0], $scope.BACKUP_DATE, colorArray_avgSpeed,legend_avgSpeed,$scope.avgSpeed,checkForNonZero_avgSpeed,avgspeed_width);
                plotWidgetBarGraph("#backupchart_totalsize", $scope.BACKUP_GRAPH2_VALUES, $scope.BACKUP_GRAPH2_TOOLTIPS[0], $scope.BACKUP_DATE, colorArray,legends,totalSize,checkForNonZero_totalSize,totalsize_width);
                plotWidgetBarGraph("#backupchart_datareduction", $scope.BACKUP_GRAPH3_VALUES,$scope.BACKUP_GRAPH3_TOOLTIPS[0],$scope.BACKUP_DATE,colorArray,legends,avgSpeed2,checkForNonZero_avgSpeed2,datareduction_width);
            })
            .error(function(data, status, headers) {
            });
    };
    /*to Get User prefrence*/
    $scope.userPrefernce = function(){
        $rootScope.manualRefreshControl($rootScope.listOfTimer[0]/1000,$scope.widgetName);
    };
    /*Function to load The Widget*/
    $rootScope.getBackupRefereshData = function(){
        $http({
            method: 'GET',
            url: '/api/summary/counts/backup/'
        })
            .success(function(data, status, headers) {
                //var timestamp=data.timestamp *1000;
                $scope.timeStamp = data.last_updated;//getDateString(timestamp);
                $scope.backupErrors=data.backup_errors;
                $scope.backupNotProtected=data.backup_not_protected;
                $scope.backupProtected=data.backup_protected;


            })
            .error(function(data, status, headers) {
                console.log('error');
            });

    };

    $scope.getBackupSummary = function(){
        $http({
            method: 'GET',
            url: '/api/summary/status/?days=1&totals=1'
        })
        .success(function(data, status, headers) {
            if (data !== undefined && data.days !== undefined) {
                var days = data.days;
                if (days instanceof Array) {
                    if (days[0].day !== undefined) {
                        var lastDay = days[0].day;

                        /* Build status pie chart data */
                        var dataset = [];
                        var allZeroes = true;
                        for (var prop in lastDay) {
                            if (lastDay.hasOwnProperty(prop)) {
                                if (lastDay[prop] > 0) {
                                    allZeroes = false;
                                }
                                var obj = {label: prop, count: lastDay[prop]};
                                dataset.push(obj);
                            }
                        }
                        $scope.lastBackupsEmpty = allZeroes;
                        $scope.daySummary = dataset;
                    }
                }
            }
        })
        .error(function(data, status, headers) {
            console.log('error');
            $scope.lastBackupsEmpty = true;
        });

    };

    $scope.viewLabel = "Pie chart view";
    $scope.graphShow=false;

    $scope.hideTable = function() {
        $('.toggle-table').hide();
    };
    $scope.toggleView = function() {
        //$(".toggle-graph-table").toggle();
        if ($scope.graphShow) {
            $scope.$broadcast('FLIP_EVENT_OUT');
        } else {
            $scope.$broadcast('FLIP_EVENT_IN');
            $scope.resetFlipSide();
            $scope.showGraph();
        }
        $scope.graphShow = !$scope.graphShow;
        $scope.viewLabel = ($scope.graphShow === true ? "Bar chart view" : "Pie chart view");

    };

    $scope.showGraph = function() {

        var avgspeed_width = $('#flipped_backupchart_avgspeed').width();
        var avgspeed_height = 150;

        var legends = [
            gettextCatalog.getString('Failures'),
            gettextCatalog.getString('Warnings'),
            gettextCatalog.getString('Successes')
        ];
        var colors = ['#bc3d41', '#d9d420', '#80bc3d'];

        if (!$scope.lastBackupsEmpty) {
            createBackupsDonut("#last_backup_status_chart", $scope.daySummary, colors, legends, avgspeed_width, avgspeed_height);
        }

        plotWidgetBarGraph("#flipped_backupchart_avgspeed", $scope.BACKUP_GRAPH_VALUES, $scope.BACKUP_GRAPH_TOOLTIPS[0],
            $scope.BACKUP_DATE, colorArray_avgSpeed,legend_avgSpeed,$scope.avgSpeed,checkForNonZero_avgSpeed,avgspeed_width, avgspeed_height);

        $scope.protectedEmpty =  ($scope.backupProtected === 0 && $scope.backupNotProtected === 0);

        if (!$scope.protectedEmpty) {
            legends = [
                gettextCatalog.getString('Protected'),
                gettextCatalog.getString('Unprotected')];
            colors = ['#80bc3d', '#d9d420'];

            var protectSummary = [
                {label: 'protected', 'count': $scope.backupProtected },
                {label: 'unprotected', 'count': $scope.backupNotProtected }
            ];
            createBackupsDonut("#protected_unprotected_donut", protectSummary, colors, legends, avgspeed_width, avgspeed_height);
        }
    };

    $scope.resetFlipSide = function() {
        $("#last_backup_status_chart").empty();
        $("#flipped_backupchart_avgspeed").empty();
        $("#protected_unprotected_donut").empty();
    };
	
	$rootScope.getSummary = $scope.getSummary;

    if ($scope.user.loggedIn) {
        $scope.userPrefernce();
        $scope.getSummary($scope.user.token);
        $scope.getBackupRefereshData();
        $scope.getBackupSummary();
    }

    $(document)
        .on("login", stopAll)
        .on("logout", stopAll)
        .on("uinav.protect", stopAll)
        .on("uinav.recover", stopAll)
        .on("uinav.jobs", stopAll)
        .on("uinav.configure", stopAll)
        .on("uinav.reports", stopAll);

    function stopAll(event) {
        clearInterval($rootScope.listOfTimerFunction[0]);
        $scope.reSizeGraph=false;
        $(document).off("uinav.protect", stopAll);
        $(document).off("uinav.recover", stopAll);
        $(document).off("uinav.jobs", stopAll);
        $(document).off("uinav.configure", stopAll);
        $(document).off("uinav.reports", stopAll);
        $(document).off("login", stopAll);
        $(document).off("logout", stopAll);
    }

    $scope.redrawCharts = function() {
        var avgspeed_width = $('#backupchart_avgspeed').width();
        var totalsize_width = $('#backupchart_totalsize').width();
        var datareduction_width = $('#backupchart_datareduction').width();
        $('#backupchart_avgspeed').empty();
        $('#backupchart_totalsize').empty();
        $('#backupchart_datareduction').empty();
        firstValue=[];
        lastValue=[];
        plotWidgetBarGraph("#backupchart_avgspeed", $scope.BACKUP_GRAPH_VALUES, $scope.BACKUP_GRAPH_TOOLTIPS[0], $scope.BACKUP_DATE, colorArray_avgSpeed,legend_avgSpeed,$scope.avgSpeed,checkForNonZero_avgSpeed,avgspeed_width);
        plotWidgetBarGraph("#backupchart_totalsize", $scope.BACKUP_GRAPH2_VALUES, $scope.BACKUP_GRAPH2_TOOLTIPS[0], $scope.BACKUP_DATE, colorArray,legends,totalSize,checkForNonZero_totalSize,totalsize_width);
        plotWidgetBarGraph("#backupchart_datareduction", $scope.BACKUP_GRAPH3_VALUES,$scope.BACKUP_GRAPH3_TOOLTIPS[0],$scope.BACKUP_DATE,colorArray,legends,avgSpeed2,checkForNonZero_avgSpeed2,datareduction_width);
    };
    $scope.$on("languageChanged", function (event){
        if ($scope.reSizeGraph === true) {
            legend_avgSpeed=[gettextCatalog.getString("Backups")];
            legends=[
                gettextCatalog.getString("Read"),
                gettextCatalog.getString("Write"),
                gettextCatalog.getString("Dedup")
            ];
            $scope.getSummary();
        }
    });
    $(window).on("resize", function(event){
        if ($scope.reSizeGraph === true) {
            $scope.redrawCharts();
        }
    });
		

$( ".panel" )
  .mouseover(function() {
    $( this ).find( ".highlight-identifier" ).removeClass("span-color");
    $( this ).find( ".highlight-identifier" ).addClass("span-color-dark");
  })
  .mouseout(function() {
    $( this ).find( ".highlight-identifier" ).removeClass("span-color-dark");
    $( this ).find( ".highlight-identifier" ).addClass("span-color");
    
  });
    
});

	 function labelBarChart_type(r, bc, labels, attrs,y_offset,x_offset,maxValue,checkForNonZero ,div_size) {
						var check_div_size = div_size -15;
						if (check_div_size < 150)
						{
							attrs.font="6px sans-serif";
						}
						else if (check_div_size < 200)
                        {
                            attrs.font="8px sans-serif";
                        }
						var vgutter=20 ; //by Default vgutter 
						var yPoint=5;//starting point on y-axis as set in  plotBarGraph_BackupWidget
						Y_coOrdiante=vgutter+yPoint; // y-coOrdinate of maximum valued graph
						
						var line_width = div_size - 45;
						r.text(line_width, 15, maxValue).attr({ font: "10px sans-serif" });
						var LineOnTop=r.path( ["M", 10 ,Y_coOrdiante, "L", (div_size-13), Y_coOrdiante] );
						LineOnTop.translate(0.5, 0.5);
                        LineOnTop.attr ({"stroke":"#D3D3D3","opacity":".75"});
                  
						
			if (checkForNonZero > 0){
                var lastIndex = bc.bars[0].length -1;
                var LastIdOfBarchart= bc.bars.length-1;
					for (var i = 0; i < bc.bars[0].length; i++) {
									
						var bar = bc.bars[0][i];
                        if ( i== 0){
                        
                            firstValue.push(bar.id);
                        } else if(i == lastIndex) {
                            
                            lastValue.push(bc.bars[LastIdOfBarchart][i].id);
                        }
						var gutter_y = bar.w * y_offset;
						var label_x = bar.x + x_offset;
						var label_y = bar.y + bar.h + gutter_y;
						var label_text = labels[i];
						r.text(label_x, label_y, label_text).attr(attrs);
					}
            }
		}

    function getToolTipPosition(id) {
            if (firstValue.indexOf(id) != -1) {
                return "right";
            }else if (lastValue.indexOf(id) != -1){
                return "left";
            }else {
                return "up";
            }
    }
	function plotBarGraph_BackupWidget(r, dataValues,tooltipUnits,dates,colorArray,legends,maxValue,checkForNonZero,div_size) {
		var fin = function () {
			var toolTipPoistion = getToolTipPosition(this.bar.id)
			var barValue = this.bar.value + "" + tooltipUnits;
			this.flag = r.popup(this.bar.x, this.bar.y, barValue || "0", toolTipPoistion).insertBefore(this).toFront();
			this.flag.animate({opacity: 1}, 300);
			this.flag.attr("opacity", 1);
			this.flag.attr({"font": "10px sans-serif"});
			this.flag.attr({"text-anchor": "middle"});
			this.flag.attr({"padding": "0px"});
		};

		var fout = function () {
			this.flag.animate({opacity: 0}, 300, function () {
				this.remove();
			});
		};


		var x_coOrdinate = (div_size / 2) - 79;
		var barchartwidth = div_size - 30; //div_size - 70;

		var barchart_value = r.barchart(20, 5, barchartwidth, 100, dataValues, {
			stacked: false,
			colors: colorArray
		}).hover(fin, fout);

		if (legends.length > 2) {
			labelBarChart_type(r, barchart_value, dates, {
				fill: "black",
				font: "10px sans-serif"
			}, 0.90, 8, maxValue, checkForNonZero, div_size);
			r.rect(x_coOrdinate, 108, 8, 8).attr({fill: colorArray[0], stroke: colorArray[0]});
			r.text(x_coOrdinate + 25, 112, legends[0]).attr({font: "10px sans-serif"});
			r.rect(x_coOrdinate + 60, 108, 8, 8).attr({fill: colorArray[1], stroke: colorArray[1]});
			r.text(x_coOrdinate + 85, 112, legends[1]).attr({font: "10px sans-serif"});
			r.rect(x_coOrdinate + 115, 108, 8, 8).attr({fill: colorArray[2], stroke: colorArray[2]});
			r.text(x_coOrdinate + 145, 112, legends[2]).attr({font: "10px sans-serif"});
		}
		else if (legends.length > 1) {
			labelBarChart_type(r, barchart_value, dates, {
				fill: "black",
				font: "10px sans-serif"
			}, 0.50, 8, maxValue, checkForNonZero, div_size);
			r.rect(x_coOrdinate, 108, 8, 8).attr({fill: colorArray[0], stroke: colorArray[0]});
			r.text(x_coOrdinate + 30, 112, legends[0]).attr({font: "10px sans-serif"});
			r.rect(x_coOrdinate + 85, 108, 8, 8).attr({fill: colorArray[1], stroke: colorArray[1]});
			r.text(x_coOrdinate + 117, 112, legends[1]).attr({font: "10px sans-serif"});
		}
		else //legend should be in centre for single BarChart
		{
			labelBarChart_type(r, barchart_value, dates, { fill: "black", font: "10px sans-serif" } ,.30,0,maxValue,checkForNonZero,div_size);
			r.text(((barchartwidth/2)), 112, legends[0]).attr({ font: "10px sans-serif" });
		}

	}

    function plotWidgetBarGraph($element, valuesArrays,tooltipUnits,dates,colors,legends,maxValue,checkForNonZero,componentWidth, componentHeight) {
    
        var barData = [];
        if (dates instanceof Array) {
            for (var i = 0; i < dates.length; i++) {
                var obj = {'x': dates[i]};
                var yVals = {};
                for (k = 0; k < legends.length; k++) {
                    var valuesArray = valuesArrays[k];
                    yVals[legends[k]] = valuesArray !== undefined ? valuesArray[i] : 0;
                }
                obj.y = yVals;
                barData.push(obj);
            }
        }

        if (componentHeight === undefined) {
            componentHeight = 104;
        }
    
        var	WIDTH = componentWidth,
            HEIGHT = componentHeight,
            MARGINS = {
                top: 18,
                right: 20,
                bottom: 18,
                left: 20
            };

        var tip = d3.tip()
            .attr('class', 'd3-tip')
            .offset([-6, 0])
            .html(function(d) { return d.tooltip; });
        
        var color = d3.scaleOrdinal().range(colors);
       
        var svg = d3.select($element).append("svg")
            .attr("class", "svg-graph-area");
   
    
        var xRange = d3.scaleBand().range([MARGINS.left, WIDTH - MARGINS.right]).padding(0.1);
        xRange.domain(barData.map(function(d) { return d.x;}));
    
        var x1 = d3.scaleBand();
        
        barData.forEach(function(d) {
            d.values = legends.map(function(name) {
                var tooltip = +d.y[name] + ' ' + tooltipUnits;
                return {name: name, y: +d.y[name], "tooltip": tooltip };
            });
        });
        
        var maxY = d3.max(barData, function(d) { return d3.max(d.values, function(d) { return d.y; }); });
    
        var yRange = d3.scaleLinear().range([HEIGHT - MARGINS.top - MARGINS.bottom, 0]).domain([0, maxY]);
    
        var xAxis = d3.axisBottom()
            .scale(xRange)
            .tickSize(5);
    
        var yAxis = d3.axisLeft()
            .scale(yRange)
            .tickSize(5);

        svg.append('svg:g')
            .attr('class', 'x axis')
            .attr('transform', 'translate(0,' + (HEIGHT - MARGINS.top) + ')')
            .call(xAxis);
    
        x1.domain(legends).range([0, xRange.bandwidth()]);
    
        var group = svg.selectAll("group")
            .data(barData)
            .enter().append("g")
            .attr("transform", function(d) {return "translate(" + xRange(d.x) + "," + MARGINS.top + ")"; });

        var bars = group.selectAll('rect')
            .data(function(d) {
                return d.values;
            })
            .enter()
            .append('rect')
            .attr('class',function(d){ return "graph-bars " + d.name+"-bar-class" })
            .attr('x', function(d) {
                return x1(d.name);
            })
            .attr("y", function(d) {
                return HEIGHT - MARGINS.top - MARGINS.bottom; //return yRange(d.y);
            })
            .attr('width', x1.bandwidth())
            .attr('height', function(d) {
                return 0; //return (d.y === 0 ? 0 : ((HEIGHT - MARGINS.bottom) - yRange(d.y)));
            })
            .style("fill", function(d) { return color(d.name); })
            .on('mouseover', function(d, i) {
                d3.select(this).classed("bar-chart-mouseover", true);
                return tip.show(d);
            })
            .on('mouseout', function(d) {
                d3.select(this).classed("bar-chart-mouseover", false);
                return tip.hide(d);
            });
    
        bars.transition()
            .duration(500)
            .delay(100)
            .attr('y', function(d) {
                return yRange(d.y);
            })
            .attr('height', function(d) {
                return (d.y === 0 ? 0: ((HEIGHT - MARGINS.top - MARGINS.bottom) - yRange(d.y)));
            });

        svg.append("line")
            .attr("class", "bar-graph-line")
            .attr("x1", MARGINS.left)
            .attr("y1", MARGINS.top)
            .attr("x2", componentWidth - MARGINS.right)
            .attr("y2", MARGINS.top);

        svg.append("text")
            .text(maxValue)
            .attr("x", componentWidth - MARGINS.right - 60)
            .attr("y", MARGINS.top - 6);

        svg.select(".x.axis")
            .selectAll("text")
            .style("font", componentWidth < 180 ? "6px sans-serif" : componentWidth < 230 ? "8px sans-serif" : "10px sans-serif");

        // REQUIRED:  Call the tooltip on the context of the visualization
        svg.call(tip);

        createChartLegend($element, svg, legends, color, HEIGHT, WIDTH, MARGINS);

    }

    function createChartLegend($element, svg, legends, color, HEIGHT, WIDTH, MARGINS, offset) {
        var xpos = offset === undefined ? 0 : offset;
        var startxpos = xpos;

        if (legends.length > 1) {

            var ypos = 0;
            var width_per_length = WIDTH/legends.length;
            var newxpos = width_per_length - (legends.length === 2 ? 60 : 30);
            var maxwidth = 0;

            var otherBars, otherBoxes, legendBars;

            var legend = svg.selectAll(".legend")
                .data(legends)
                .enter()
                .append("g")
                .attr("class", "legend")
                .attr("cursor", "default")
                .on('mouseover', function(d, i) {
                    legendBars = $($element).find('.'+d+'-bar-class');
                    d3.selectAll(legendBars)
                        .transition()
                        .duration(300)
                        .style("opacity",1);
                    otherBars = $($element + ' rect').not('.'+d+'-bar-class').not(".legend-box");
                    d3.selectAll(otherBars)
                        .transition()
                        .duration(300)
                        .style("opacity",0.1);

                })
                .on('mouseout', function(d) {
                    d3.selectAll(otherBars)
                        .transition()
                        .duration(300)
                        .style("opacity",0.8);
                    d3.selectAll(legendBars)
                        .transition()
                        .duration(300)
                        .style("opacity",0.8);
                });

            legend.append("rect")
                .attr("x", 0)
                .attr("y", HEIGHT - MARGINS.top + 26)
                .attr("width", 8)
                .attr("height", 8)
                .attr("class", "legend-box")
                .style("fill", color);


            legend.append("text")
                .attr("x", 12)
                .attr("y", HEIGHT - MARGINS.top + 30)
                .attr("dy", ".35em")
                .style("text-anchor", "start")
                .text(function(d) { return d; });

            legend.attr("transform", function(d, i) {
                var length = d3.select(this).select('text').node().getComputedTextLength() + 30;
                xpos = startxpos + newxpos;

                if (WIDTH < xpos + length) {
                    if (WIDTH + MARGINS.right >= xpos + length) {
                        xpos = newxpos - 10;
                    } else {
                        newxpos = xpos = WIDTH / width_per_length - (legends.length === 2 ? 60 : 30);
                        ypos += 20;
                    }
                }

                newxpos += length;
                if (newxpos > maxwidth) {
                    maxwidth = newxpos;
                }

                return 'translate(' + xpos + ',' + ypos + ')';
            });

        } else {
            svg.append("text")
                .attr("transform", "translate(" + (WIDTH / 2 - 16 + xpos) + ',' + (HEIGHT - MARGINS.top + 30) + ")")
                .text(legends[0]);
        }
    }

function plotWidgetLineGraph($element, valuesArrays,tooltipUnits,dates,colors,legends,maxValue,checkForNonZero,componentWidth) {

    var barData = [];
    for (var i = 0; i < dates.length; i++) {
        var obj = {'x': dates[i]};
        var yVals = {};
        for (k = 0; k < legends.length; k++) {
            var valuesArray = valuesArrays[k];
            yVals[legends[k]] = valuesArray !== undefined ? valuesArray[i] : 0;
        }
        obj.y = yVals;
        barData.push(obj);
    }

    var	WIDTH = componentWidth,
        HEIGHT = 104,
        MARGINS = {
            top: 18,
            right: 20,
            bottom: 18,
            left: 20
        };

    var tip = d3.tip()
        .attr('class', 'd3-tip')
        .offset([-6, 0])
        .html(function(d) { return d.tooltip; });

    var color = d3.scaleOrdinal().range(colors);

    var width = WIDTH;

    var height = HEIGHT;

    var svg = d3.select($element).append('svg')
        .attr('class', 'svg-graph-area')
        .attr('width', width)
        .attr('height', height)
        .append('g')
        .attr('transform', 'translate(' + MARGINS.left + ', ' + MARGINS.top + ')');

    var valueline = d3.line()
        .defined(function(d) { return d; })
        //.curve(d3.curveBasis)
        .x(function (d) {
            return x(d.x);
        })
        .y(function (d) {
            return y(d.y);
        });

    var x = d3.scaleOrdinal()
        .range([0, width - MARGINS.left - MARGINS.right]);

    var y = d3.scaleLinear()
        .range([height - MARGINS.top - MARGINS.bottom, 0]);

    x.domain(d3.extent(barData, function (d) {
        return d.x;
    }));
    y.domain([0, d3.max(barData, function (d) {
        return +d.y.Read;
    })]);

    var xAxis = d3.axisBottom()
        .scale(x)
        .ticks(7)
        .tickPadding(8);

    var yAxis = d3.axisLeft()
        .scale(y)
        .tickPadding(8);

    // Create x-axis, with date labels, rotated
    svg.append('g')
        .attr('class', 'x d3-axis')
        .attr('transform', 'translate(0, ' + (height - MARGINS.top - MARGINS.bottom) + ')')
        .call(xAxis)
        .selectAll("text")
        .style("text-anchor", "end")
        .attr("dx", "-.8em")
        .attr("dy", ".15em")
        .attr("transform", function (d) {
            return "rotate(-65)"
        });

    // Create y-axis
    svg.append('g')
        .attr('class', 'y d3-axis')
        .call(yAxis);

    // Add y-axis title near the left margin
    svg.append("text")
        .attr("text-anchor", "middle")
        // text is drawn off the screen top left, move down and out and rotate
        .attr("transform", "translate(-" + (MARGINS.left - 16) + "," + ((height - MARGINS.top - MARGINS.bottom) / 2) + ")rotate(-90)")
        .text("Size (GB)");

    // Color map for line color.
    var colorOf = function (id) {
        var color = 'black';
        for (var i = 0; i < dataNest.length; i++) {
            var key = dataNest[i].key;
            if (key == id) {
                color = colors[i % colors.length];
                break;
            }
        }
        return color;
    };


    for (i = 0; i < legends.length; i++) {
        var index = legends[i];

        var data = [];
        for (var j = 0; j < barData.length; j++) {
            var obj = {x:barData[j].x, y:barData[j].y[index], name:index};
            data.push(obj);
        }
        // Create each line
        svg.append("path")
            .datum(data)
            .attr('class', 'line')
            .attr('d', valueline)
            .attr('stroke-width', 2)
            .style("stroke", colors[i])
            .attr('fill', 'none');

        // Add a line label at the end.
        svg.append("text")
            .datum(data)
            .attr("transform", "translate(" + x(data[data.length - 1]) + "," + y(data[data.length - 1]) + ")")
            .attr("x", 3)
            .attr("dy", "0.35em")
            .style("font", "10px sans-serif")
            .text(data[0].name);
    }

    // REQUIRED:  Call the tooltip on the context of the visualization
    //svg.call(tip);

    if (legends.length > 1) {

        var ypos = 0;
        var width_per_length = WIDTH/legends.length;
        var newxpos = width_per_length - (legends.length === 2 ? 60 : 30);
        var maxwidth = 0;
        var xpos = 0;

        var otherBars, otherBoxes, legendBars;

        var legend = svg.selectAll(".legend")
            .data(legends)
            .enter()
            .append("g")
            .attr("class", "legend")
            .attr("cursor", "default")
            .on('mouseover', function(d, i) {
                legendBars = $($element).find('.'+d+'-bar-class');
                d3.selectAll(legendBars)
                    .transition()
                    .duration(300)
                    .style("opacity",1);
                otherBars = $($element + ' rect').not('.'+d+'-bar-class').not(".legend-box");
                d3.selectAll(otherBars)
                    .transition()
                    .duration(300)
                    .style("opacity",0.1);

            })
            .on('mouseout', function(d) {
                d3.selectAll(otherBars)
                    .transition()
                    .duration(300)
                    .style("opacity",0.8);
                d3.selectAll(legendBars)
                    .transition()
                    .duration(300)
                    .style("opacity",0.8);
            });

        legend.append("rect")
            .attr("x", 0)
            .attr("y", HEIGHT - MARGINS.top + 26)
            .attr("width", 8)
            .attr("height", 8)
            .attr("class", "legend-box")
            .style("fill", color);


        legend.append("text")
            .attr("x", 12)
            .attr("y", HEIGHT - MARGINS.top + 30)
            .attr("dy", ".35em")
            .style("text-anchor", "start")
            .text(function(d) { return d; });

        legend.attr("transform", function(d, i) {
            var length = d3.select(this).select('text').node().getComputedTextLength() + 30;
            xpos = newxpos;

            if (WIDTH < xpos + length) {
                if (WIDTH + MARGINS.right >= xpos + length) {
                    xpos = newxpos - 10;
                } else {
                    if (width_per_length === 0) {
                        newxpos = xpos = 0 - (legends.length === 2 ? 60 : 30);
                    } else {
                        newxpos = xpos = WIDTH / width_per_length - (legends.length === 2 ? 60 : 30);
                    }
                    ypos += 20;
                }
            }

            newxpos += length;
            if (newxpos > maxwidth) {
                maxwidth = newxpos;
            }

            return 'translate(' + xpos + ',' + ypos + ')';
        });

    } else {
        svg.append("text")
            .attr("transform", "translate(" + (WIDTH / 2 - 16) + ',' + (HEIGHT - MARGINS.top + 30) + ")")
            .text(legends[0]);
    }

}

function createBackupsDonut($element, dataset, colorArray, legends, chart_width, chart_height) {

    var width = chart_width; //360;
    var height = chart_height !== undefined ? chart_height : 200;
    var radius = Math.min(width, height) / 2;
    var donutWidth = 30;                        // NEW
    var colors = [];
    colors['failures'] = '#bc3d41';
    colors['warnings'] = colors['unprotected'] = '#d9d420';
    colors['successes'] = colors['protected'] = '#80bc3d';
    colors['in_progress'] = '#bbbbbb';

    var colorRange = d3.scaleOrdinal().range(colorArray);

    var MARGINS = {
        top: 18,
        right: 20,
        bottom: 18,
        left: 20
    };

    var colorOf = function(name) {
        return colors[name];
    };

    var svg = d3.select($element).append('svg')
        .attr('class', 'svg-graph-area')
        .attr('width', width)
        .attr('height', height)
        .append('g')
        .attr('transform', 'translate(' + (width / 2) + ',' + (height / 2) + ')');

    var arc = d3.arc()
        .innerRadius(radius - donutWidth)             // UPDATED
        .outerRadius(radius);

    var pie = d3.pie()
        .value(function(d) { return d.count; })
        .sort(null);

    var tooltip = d3.select($element)
        .append('div')
        .attr('class', 'donut-tooltip');

    tooltip.append('div')
        .attr('class', 'donut-tooltip');

    tooltip.append('div')
        .attr('class', 'label');

    tooltip.append('div')
        .attr('class', 'count');

    tooltip.append('div')
        .attr('class', 'percent');

    var path = svg.selectAll('path')
        .data(pie(dataset))
        .enter()
        .append('path')
        .attr('d', arc)
        .attr('fill', function(d, i) {
            return colorOf(d.data.label);
        });

    path.on('mouseover', function(d) {                            
        var total = d3.sum(dataset.map(function(d) {                
            return d.count;                                           
        }));                                                        
        var percent = Math.round(1000 * d.data.count / total) / 10;
        tooltip.select('.label').html(d.data.label);                
        tooltip.select('.count').html(d.data.count);                
        tooltip.select('.percent').html(percent + '%');             
        tooltip.style('display', 'block');                          
    });

    path.on('mouseout', function() {                              
        tooltip.style('display', 'none');                           
    });

    createChartLegend($element, svg, legends, colorRange, 80, width, MARGINS, legends.length === 3 ? -150 : -135);
}



