
var JOB_TYPE_UNKNOWN=0,
    JOB_TYPE_BACKUP=1,
    JOB_TYPE_RESTORE=2,
    JOB_TYPE_ROLLBACK=3,
    JOB_TYPE_REPLICATION=4,
    JOB_TYPE_NCDP=5,
    JOB_TYPE_INSTANT_RESTORE=6,
    JOB_TYPE_LINK=7,
    JOB_TYPE_DELETE=8,
    JOB_TYPE_BDSIO=9,
    JOB_TYPE_VERIFY=10,
    JOB_TYPE_ORPHAN_HUNT=11,
    JOB_TYPE_SNAPSHOT_HUNT=12,
    JOB_TYPE_HYPERVISOR=13,
    JOB_TYPE_BACKUP_DISK=14,
    JOB_TYPE_ARCHIVE=16,
    JOB_TYPE_IR_START=18,
    JOB_TYPE_IR_SEED=19,
    JOB_TYPE_IR_MOTION=20,
    JOB_TYPE_IR_END=21,
    JOB_TYPE_CERTIFICATION=22,
    JOB_TYPE_ARCHIVE_DISK=17,
    JOB_TYPE_RESTORE_DISK=15,

    RECOVERY_JOB_TYPE_STANDARD=1,
    RECOVERY_JOB_TYPE_ROLLBACK=0,
    RECOVERY_JOB_TYPE_INSTANT=2,

    // Password length
    MAX_PASSWORD_LENGTH = 64,

    HYPERVISOR_NA=0,
    HYPERVISOR_XEN=1,
    HYPERVISOR_VMWARE=3,
    HYPERVISOR_HYPERV=4,
    HYPERVISOR_VMWARE_STANDALONE_HOST=5,
    HYPERVISOR_AHV=6,

    DEFAULT_XEN_VIEW=6,
    DEFAULT_VMWARE_VIEW=3,
    DEFAULT_HYPERV_VIEW=10,

    ALERT_TYPE_UNKNOWN=0,
    ALERT_TYPE_OTHER=1,
    ALERT_TYPE_LICENSE_EXPIRED=2,
    ALERT_TYPE_LICENSE_INVALID=3,
    ALERT_TYPE_UPDATES_AVAILABLE=4,
    ALERT_TYPE_BDS_CREATE=5,
    ALERT_TYPE_BDS_CONNECTIVITY=6,
    ALERT_TYPE_BDS_LOW_SPACE=7,
    ALERT_TYPE_VBA_CONNECTIVITY=8,
    ALERT_TYPE_BACKUP_WINDOW=9,
    ALERT_TYPE_BACKUP_NO_CBT=10,
    ALERT_TYPE_BACKUP_FULL=11,
    ALERT_TYPE_HYPERVISOR_SNAPSHOT=12,
    ALERT_TYPE_HYPERVISOR_LOGIN=13,
    ALERT_TYPE_UNPROTECTED_VM=14,
    ALERT_TYPE_FLR=15,
    ALERT_TYPE_INVENTORY_SYNC=16,
    ALERT_TYPE_UPDATE_COMPLETE=17,
    ALERT_TYPE_IR=18,
    ALERT_TYPE_LINK=19,
    ALERT_TYPE_EMAIL_ERROR=101,
    ALERT_TYPE_SMTP_NOT_CONFIGURED=102,

    // lmc - backup "types"
    BACKUP_MODE_VIRTUAL_FULL=1,
    BACKUP_MODE_FULL_AND_INC=2,
    BACKUP_MODE_FULL_AND_INC_FULL=3,

    // lmc - retention settings
    ARCHIVE_RETENTION_TYPICAL=1,
    ARCHIVE_RETENTION_KEEP_ALL=2,
    ARCHIVE_RETENTION_CUSTOM=3,

    // lmc - storage status
    CONN_STATUS_UNKNOWN=0,
    CONN_STATUS_OFF=1,
    CONN_STATUS_CANNOT_CONNECT=-1,
    CONN_STATUS_ON=2,

    // lmc - storage usage
    BDS_TYPE_BACKUP=1,
    BDS_TYPE_REPLICATION=2,
    BDS_TYPE_CLOUD_CACHE=4,
    BDS_TYPE_IR_CACHE=8,
    BDS_TYPE_ARCHIVE=16,
    BDS_TYPE_SYNC=32,

    // Storage types
    STORAGE_INTERNAL = 0,
    STORAGE_ISCSI = 1,
    STORAGE_FC = 2,
    STORAGE_NAS = 4,
    STORAGE_ADDED_INTERNAL = 5,

    // lmc - RESTlike calls to the server
    AJAX_ID_GLOBAL=0,
    AJAX_ID_NON_EXISTENT=-1,

    FALSE=0,
    TRUE=1,

    // lmc - log level definitions
    LOG_LEVEL_EMERGENCY=0,
    LOG_LEVEL_ALERT=1,
    LOG_LEVEL_CRITICAL=2,
    LOG_LEVEL_ERROR=3,
    LOG_LEVEL_WARNING=4,
    LOG_LEVEL_NOTICE=5,
    LOG_LEVEL_INFO=6,

    // lmc - removed unused INV_TYPE constants
    INV_TYPE_UNIVERSE=8,

    // lmc - REST API return codes
    AJAX_RESULT_SUCCESS=0,
    AJAX_RESULT_PARTIAL_SUCCESS=3,
    AJAX_RESULT_WARNING=1,
    AJAX_RESULT_UNAUTHENTICATED=-1,
    AJAX_RESULT_ERROR=2,

    // lmc - verify types
    VERIFY_TYPE_NONE=1,
    VERIFY_TYPE_QUICK=2,
    VERIFY_TYPE_FULL=3,

    // lmc - presentation layer - job manager tab IDs
    JOB_TAB_ACTIVE=0,
    JOB_TAB_MANAGER=1,
    JOB_TAB_HISTORY=2,
    JOB_TAB_SYSTEM=3,
    JOB_TAB_POLICIES=4,
    JOB_TAB_CALENDAR=5,

    // lmc - instant recovery state
    INSTANT_VM_STATE_UNKNOWN=0,
    INSTANT_VM_STATE_CREATING=1,
    INSTANT_VM_STATE_ACTIVE=2,
    INSTANT_VM_STATE_SEEDING=3,
    INSTANT_VM_STATE_READY=4,
    INSTANT_VM_STATE_COMPLETING=5,
    INSTANT_VM_STATE_COMPLETED=6,
    INSTANT_VM_STATE_ENDING=7,
    INSTANT_VM_STATE_ENDED=8,
    INSTANT_VM_STATE_ERROR=9,

    SAVE_STATE_PRESENTATION=0,
    SAVE_STATE_MANAGEMENT=1,
    SAVE_STATE_ENGINE=2,
    SAVE_STATE_FINISHED=3,

    SAVE_STATUS_ERRORS=3,
    SAVE_STATUS_PENDING=0,
    SAVE_STATUS_SAVED=1,
    SAVE_STATUS_DELETED=4,
    SAVE_STATUS_SAVED_ERRORS=2,

    EMAIL_ENCRYPTION_NONE=0,
    EMAIL_ENCRYPTION_TLS=1,
    EMAIL_ENCRYPTION_SSL=2,

    // lmc - presentation layer  - dashboard refresh in ms
    DEFAULT_JOBS_REFRESH=5000,
    DEFAULT_STORAGE_REFRESH=5000,
    DEFAULT_ALERT_REFRESH=5000,
    DEFAULT_RESTORE_REFRESH=5000,
    DEFAULT_ACTIVE_JOB_REFRESH=5000,
    DEFAULT_REPLICATION_REFRESH=5000,
    DEFAULT_BACKUP_REFRESH=5000,

    // lmc - presentation layer - widget identifiers
    BACKUP_REFRESH=0,
    REPLICATION_REFRESH=1,
    RESTORE_REFRESH=2,
    ALERT_REFRESH=3,
    ACTIVE_JOB_REFRESH=4,
    STORAGE_REFRESH=5,
    JOBS_REFRESH=6,

    UPDATE_STATUS_UNKNOWN=0,
    UPDATE_STATUS_AVAILABLE=1,
    UPDATE_STATUS_PENDING=2,
    UPDATE_STATUS_UPDATING=3,
    UPDATE_STATUS_COMPLETED=4,
    UPDATE_STATUS_FAILED=5,

    FLR_TYPE_CIFS=0,
    FLR_TYPE_ISCSI=1,

    MODE_SUBTYPE_FULL=0,
    MODE_SUBTYPE_INC=1,

    BACKUP_CATALOG_RECOVERY_DIALOG=2,
    BACKUP_CATALOG_ROLLBACK_DIALOG=3,
    BACKUP_CATALOG_TAB=0,
    BACKUP_CATALOG_VIEW_DATE=1,
    BACKUP_CATALOG_FLR_DIALOG=1,
    BACKUP_CATALOG_VIEW_BDS=3,
    BACKUP_CATALOG_VIEW_APPLIANCE = 4,

    BACKUP_CATALOG_VIEW_VM=0,
    BACKUP_CATALOG_VIEW_ROLLBACK=2,

    BACKUP_STATUS_SUCCESS = 0,
    BACKUP_STATUS_WARNING = 1,
    BACKUP_STATUS_FAILURE = 2,

    CREDENTIAL_TYPE_NONE=0,
    CREDENTIAL_TYPE_FILE_REC_CREDS=1,
    CREDENTIAL_TYPE_FROM_CONFIG=2,
    CREDENTIAL_TYPE_SYS_GEN=3,
    CREDENTIAL_TYPE_CUSTOM=4,

    LICENSING_UNLIMITED_SOCKETS=-1,

    SYNC_STATUS_PENDING=0,
    SYNC_STATUS_ACTIVE=1,
    SYNC_STATUS_ERROR=2,

    SCHEDULE_RUN_EVERY=0,
    SCHEDULE_RUN_FIRST=1,
    SCHEDULE_RUN_SECOND=2,
    SCHEDULE_RUN_THIRD=3,

    //PROTECT_SETTINGS=1,

    SCHEDULE_TYPE_SCHEDULED=4,
    SCHEDULE_TYPE_NOW=1,
    //SCHEDULE_TYPE_RUN_ONCE=2,
    //SCHEDULE_TYPE_ON_DEMAND=3,

    VERSION_UP_TO_DATE=0,
    VERSION_UPDATE_IN_PROGRESS=2,
    VERSION_NOT_UP_TO_DATE=1,

    LOCATION_OR_TARGET_TARGET=2,
    LOCATION_OR_TARGET_LOCATION=1,

    INCLUDE_NEW_HW_NONE=0,
    INCLUDE_NEW_HW_ALL=1,
    INCLUDE_NEW_HW_DISKS_ONLY=2,
    INCLUDE_NEW_HW_VM_SETTINGS_ONLY=3,

    // lmc - quiesce VM on backup
    QUIESCE_YES=1,
    QUIESCE_NO=0,

    RETENTION_KEEP_ALL=2,
    RETENTION_TYPICAL=1,

    PRIORITY_LOW=0,
    PRIORITY_MEDIUM=50,
    PRIORITY_HIGH=100,

    // lmc - presentation - report type to generate
    REPORT_TYPE_HTML=1,
    REPORT_TYPE_CSV=2,
    REPORT_TYPE_PDF=3,

    // lmc - presentation - tour/quickstart only
    ENABLE_TOUR=7,

    PROTECT_STATUS=0,

    ERR_INVENTORY = "Select at least one inventory item.",

    //LOGIN_URL = "/api/login/",

    NETWORK_TYPE_DHCP = "dhcp",
    NETWORK_TYPE_STATIC = "static",

    BLANK_LISTBOX_TEXT = "\u002D\u002D\u002D\u002D\u002D\u002D\u002D\u002D\u002D",

    //ERR_INVALID_UPDATE_FILENAME = "Invalid filename. The filename should be in this format: phdvb\u002D7.0.1.9083.phd",
    ERR_WEEKLY_RUN_DAY = "Select at least one day for the job to run.",
    ERR_START_DATE_GT_END_DATE = "The \u0027From\u0027 date cannot be after the \u0027To\u0027 date",

    KNOWLEDGE_BASE_URL = "https://unitrends-support.force.com/UnitrendsBackup/s/",
    CE_KNOWLEDGE_BASE_URL = "https://unitrends-support.force.com/UnitrendsFree/s/",
    DOCUMENTATION_URL = "https://unitrends-support.force.com/UnitrendsBackup/s/",
    CE_DOCUMENTATION_URL = "http://www.unitrends.com/docs/user-guides/unitrends-free-administrators-guide",
    CE_BROWSER_URL ="https://unitrends-support.force.com/UnitrendsFree/s/article/000003589",
    RELEASE_NOTES_URL = "http://www.unitrends.com/special-pages/categories?categoryid=79",

    DEFAULT_START_TIME = "20:00:00",
    DEFAULT_END_TIME = "04:00:00",
    DEFAULT_DO_NOT_RUN_AFTER_TIME = "23:59:00",
    DEFAULT_EMAIL_PORT = "25",
    DEFAULT_TIMEZONE = "US/Eastern",

    EMPTY_CELL_TEXT = "\u002D\u002D",
    RETENTION_VIRTUAL_FILL_SINGULAR = "Assuming one year of daily backups, these settings will keep %s Virtual Full backup per VM.",
    RETENTION_FULL_INC = "Assuming Fulls are scheduled weekly, these settings will keep %s Full and %s Incremental backups.",
    RETENTION_VIRTUAL_FILL_PLURAL = "Assuming one year of daily backups, these settings will keep %s Virtual Full backups per VM.",

    //STATIC_URL = "/static/";
	//lmc
    STATIC_URL = "assets/";

// Application IDs.
var APP_ID_FILE_LEVEL = 1,
    APP_ID_EXCHANGE_2003 = 2,
    APP_ID_EXCHANGE_2007 = 3,
    APP_ID_EXCHANGE_2010 = 4,
    APP_ID_EXCHANGE_2013 = 5,
    APP_ID_EXCHANGE_2016 = 6,
    APP_ID_SQL_SERVER_2005 = 21,
    APP_ID_SQL_SERVER_2008 = 22,
    APP_ID_SQL_SERVER_2008_R2 = 23,
    APP_ID_SQL_SERVER_2012 = 24,
    APP_ID_SQL_SERVER_2014 = 25,
    APP_ID_SQL_SERVER_2016 = 26,
    APP_ID_SQL_SERVER_2017 = 27,
    APP_ID_ARCHIVE = 30,
    APP_ID_VMWARE = 40,
    APP_ID_HYPERV_2008_R2 = 50,
    APP_ID_HYPERV_2012 = 51,
    APP_ID_HYPERV_2016 = 52,
    APP_ID_ORACLE_11 = 100,
    APP_ID_ORACLE_12 = 101,
    APP_ID_ORACLE_10 = 102,
    APP_ID_SHAREPOINT_2007 = 110,
    APP_ID_SHAREPOINT_2010 = 111,
    APP_ID_SHAREPOINT_2013 = 112,
    APP_ID_SHAREPOINT_2016 = 113,
    APP_ID_CISCO_UCS_SERVICE_PROFILE = 120,
    APP_ID_NDMP            = 130,
    APP_ID_XEN = 140,
    APP_ID_AHV = 141;


var ASSET_TYPE_PHYSICAL = "physical",
    ASSET_TYPE_VMWARE_VM = "VMware:VM",
    ASSET_TYPE_HYPER_V_VM = "Hyper-V:VM",
    ASSET_TYPE_VMWARE_HOST = "VMware Host",
    ASSET_TYPE_XEN = "Xen",
    ASSET_TYPE_NDMP = "NDMP NAS",
    ASSET_TYPE_AHV = "AHV Host",
    ASSET_TYPE_AHV_VM = "AHV:VM";

var ASSET_DISPLAY_FILTER_PHYSICAL = "Physical",
    ASSET_DISPLAY_FILTER_VIRTUAL = gettext("Virtual"),
    ASSET_DISPLAY_FILTER_ALL = "All";

var ALERT_HELP_LINKS = {

    0:"21803964",
    1:"21803964",
    2:"21803964",
    3:"21803964",
    4:"21898139",
    5:"26127905",
    6:"21898149",
    7:"25342025",
    8:"26201924",
    9:"21898159",
    10:"22391340",
    11:"22391350",
    12:"22217785",
    13:"21898199",
    14:"22391370",
    15:"22346465",
    16:"22501479",
    17:"21898139",
    18:"26374555",
    19:"28207810",
    101:"21927514",
    102:"21927504"

};

// lmc - added for UEB
var ALERT_SEVERITY_NOTICE = "notice";
var ALERT_SEVERITY_WARNING = "warning";
var ALERT_SEVERITY_CRITICAL = "critical";
//mmb
var ALERT_AT_RISK = "at_risk";

// lmc - storage warning percentage thresholds.
var STORAGE_WARNING_THRESHOLD = 75;
var STORAGE_CRITICAL_THRESHOLD = 95;

// lmc - added for UEB
var API_DIR = "/api";

//mmb - added for link to forums
var FEEDBACK_URL = "https://unitrends-support.force.com/UnitrendsFree/s";

//jtg - added for NAS data-source assets
var NAS_POSTFIX = "-NAS-RRC";

//asm - added for WIR modes
var MODE_NEW = "new";
var MODE_HALTED = "halted";
var MODE_AUDIT = "audit";
var MODE_LIVE = "live";
var MODE_IDLE = "idle"; //vmware replicas
var MODE_RESTORE = "restore" //vmware replicas

//job type for vmware replicas is returned as vmware host
var VMWARE_REPLICA_JOB_TYPE = "VMware host";


//asm - added for WIR of coped asset
var COPIED_ASSET = " (copied asset)";

//asm - added for type of hypervisor
var HYPERVISOR_UNITRENDS_APPLIANCE = "Unitrends appliance";
var HYPERVISOR_VMWARE_HOST = "VMware host";
var HYPERVISOR_HYPERV_HOST = "Hyper-V host";

//asm - Application Type Names
var APPLICATION_TYPE_NAME_FILE_LEVEL          = 'file-level',
    APPLICATION_TYPE_NAME_PHYSICAL_SERVER     = 'Physical Server',
    APPLICATION_TYPE_NAME_EXCHANGE            = 'Exchange',
    APPLICATION_TYPE_NAME_SQL_SERVER          = 'SQL Server',
    APPLICATION_TYPE_NAME_ARCHIVE             = 'Archive',
    APPLICATION_TYPE_NAME_VMWARE              = 'VMware',
    APPLICATION_TYPE_NAME_HYPER_V             = 'Hyper-V',
    APPLICATION_TYPE_NAME_SYSTEM_METADATA     = 'System Metadata',
    APPLICATION_TYPE_NAME_ORACLE              = 'Oracle',
    APPLICATION_TYPE_NAME_SHAREPOINT          = 'SharePoint',
    APPLICATION_TYPE_NAME_UCS_SERVICE_PROFILE = 'UCS Service Profile', //Cisco UCS
    APPLICATION_TYPE_NAME_VOLUME              = 'Volume',  //NDMP
    APPLICATION_TYPE_NAME_NDMP_DEVICE         = 'NDMP Device',  //NDMP device needed for job display
    APPLICATION_TYPE_NAME_XEN                 = 'Xen',
    APPLICATION_TYPE_NAME_AHV                 = 'AHV';

// Inventory ID - System Nodes
var INVENTORY_ID_SYSTEM = 1001;
var INVENTORY_ID_NAVGROUP = 1002;

// Inventory ID - Client Nodes
var INVENTORY_ID_CLIENT_AIX       = 2001;
var INVENTORY_ID_CLIENT_DOS       = 2002;
var INVENTORY_ID_CLIENT_FREE_BSD  = 2003;
var INVENTORY_ID_CLIENT_HPUX      = 2004;
var INVENTORY_ID_CLIENT_I_SERIES  = 2005;
var INVENTORY_ID_CLIENT_LINUX     = 2006;
var INVENTORY_ID_CLIENT_MAC       = 2007;
var INVENTORY_ID_CLIENT_NETWARE   = 2008;
var INVENTORY_ID_CLIENT_OES       = 2009;
var INVENTORY_ID_CLIENT_OS2       = 2010;
var INVENTORY_ID_CLIENT_SGI       = 2011;
var INVENTORY_ID_CLIENT_SCO       = 2012;
var INVENTORY_ID_CLIENT_SOLARIS   = 2013;
var INVENTORY_ID_CLIENT_UNIX      = 2014;
var INVENTORY_ID_CLIENT_WINDOWS   = 2015;
var INVENTORY_ID_CLIENT_OTHER     = 2016;

// Inventory ID - Cisco UCS Nodes
var INVENTORY_ID_CISCO_UCS_CLIENT             = 101001;
var INVENTORY_ID_CISCO_UCS_SERVICE_PROFILE    = 101002;

// Inventory ID - Exchange Nodes
var INVENTORY_ID_EXCHANGE_APPLICATION     = 102001;
var INVENTORY_ID_EXCHANGE_DATABASE        = 102002;

// Inventory ID - Hyper-V Nodes
var INVENTORY_ID_HYPER_V_SERVER           = 201002;  //Application Node
var INVENTORY_ID_HYPER_V_VM               = 201003;
var INVENTORY_ID_HYPER_V_WIR_VM           = 201007;

// Inventory ID - Oracle Nodes
var INVENTORY_ID_ORACLE_APPLICATION     = 104001;
var INVENTORY_ID_ORACLE_DATABASE        = 104002;

// Inventory ID - SharePoint Nodes
var INVENTORY_ID_SHAREPOINT_APPLICATION   = 105001;
var INVENTORY_ID_SHAREPOINT_FARM          = 105002;

// Inventory ID - SQL Nodes
var INVENTORY_ID_SQL_SERVER               = 106003; //Application Node
var INVENTORY_ID_SQL_DATABASE             = 106004;
var INVENTORY_ID_SQL_INSTANCE             = 106006;

// Inventory ID - NDMP Nodes
var INVENTORY_ID_NDMP_CLIENT              = 103001;
var INVENTORY_ID_NDMP_VOLUME              = 103002;

// Inventory ID - VMware Nodes
var INVENTORY_ID_VMWARE_CLUSTER           = 202004;
var INVENTORY_ID_VMWARE_ESX_SERVER        = 202005;
var INVENTORY_ID_VMWARE_FOLDER            = 202006;
var INVENTORY_ID_VMWARE_RESOURCE_POOL     = 202007;
var INVENTORY_ID_VMWARE_V_APP             = 202008;
var INVENTORY_ID_VMWARE_VM                = 202009;
var INVENTORY_ID_VMWARE_TEMPLATE          = 202010;
var INVENTORY_ID_VMWARE_VM_DISK           = 202011;
var INVENTORY_ID_VMWARE_WIR_VM            = 202012;

//XEN
var INVENTORY_ID_XEN_POOL_MASTER          = 203001;
var INVENTORY_ID_XEN_STANDALONE_SERVER    = 203002;
var INVENTORY_ID_XEN_SERVER_IN_A_POOL     = 203003;
var INVENTORY_ID_XEN_VM                   = 203007;
var INVENTORY_ID_XEN_VM_DISK              = 203008;
var INVENTORY_ID_XEN_CUSTOM_TEMPLATE      = 203009;

//AHV
var INVENTORY_ID_AHV_CLUSTER              = 204001;
var INVENTORY_ID_AHV_VM                   = 204002;
var INVENTORY_ID_AHV_VM_DISK              = 203003;

// Inventory Type Family
var INVENTORY_TYPE_FAMILY_SYSTEM      = 1000;
var INVENTORY_TYPE_FAMILY_NAVGROUP    = 1001;
var INVENTORY_TYPE_FAMILY_CLIENT      = 2000;
var INVENTORY_TYPE_FAMILY_CISCO_UCS   = 101000;
var INVENTORY_TYPE_FAMILY_EXCHANGE    = 102000;
var INVENTORY_TYPE_FAMILY_HYPER_V     = 201000;
var INVENTORY_TYPE_FAMILY_ORACLE      = 104000;
var INVENTORY_TYPE_FAMILY_SHAREPOINT  = 105000;
var INVENTORY_TYPE_FAMILY_SQL         = 106000;
var INVENTORY_TYPE_FAMILY_VMWARE      = 202000;
var INVENTORY_TYPE_FAMILY_XEN         = 203000;
var INVENTORY_TYPE_FAMILY_AHV         = 204000;
var INVENTORY_TYPE_FAMILY_CLIENT_NAS  = 2100;// NAS is only handled in UI
var INVENTORY_TYPE_FAMILY_NDMP        = 103000;

// Quiesce Setting Display Name
var QUIESCE_MULTIPLE_SETTINGS                           = 'multiple';
var QUIESCE_SETTING_DISPLAY_NAME_APPLICATION_CONSISTENT = 'Application Consistent';
var QUIESCE_SETTING_DISPLAY_NAME_APPLICATION_AWARE      = 'Application Aware';
var QUIESCE_SETTING_DISPLAY_NAME_CRASH_CONSISTENT       = 'Crash Consistent';
var QUIESCE_CURRENT_DEFAULT_MESSAGE_STRING_1_of_2       = 'The default quiesce setting for this appliance is ';
var QUIESCE_CURRENT_DEFAULT_MESSAGE_STRING_2_of_2       = '.  To edit this setting, please open the Manage Global VM Settings dialogue on the Protected Assets tab of the Configure page.';

//User roles
var SYSTEM_ROLE_DISPLAY_NAME_BACKUP_SYSTEM                    = 'Backup System'; 
var SYSTEM_ROLE_DISPLAY_NAME_MANAGER                          = 'Manager';
var SYSTEM_ROLE_DISPLAY_NAME_TARGET                           = 'Target';
var SYSTEM_ROLE_DISPLAY_NAME_MANAGED_DPU                      = 'Managed DPU';
var SYSTEM_ROLE_DISPLAY_NAME_DPU_CONFIGURED_FOR_VAULTING      = 'DPU Configured for Vaulting';
var SYSTEM_ROLE_DISPLAY_NAME_REPLICATION_SOURCE               = 'Replication Source';
var SYSTEM_ROLE_DISPLAY_NAME_NON_MANAGED_REPLICATION_SOURCE   = 'Non-Managed Replication Source';
var SYSTEM_ROLE_DISPLAY_NAME_PENDING_REPLICATION_SOURCE       = 'Pending Replication Source';

//Job Status
var CANCELLED 	= "Cancelled";
var IDLE 		= "Idle";
var RUNNING 	= "Running";
var WARNING		= "Warning";
var ACTIVE		= "Active";
var QUEUED		= "Queued";
var PAUSED		= "Paused";
var SUCCESSFUL	= "Successful";
var ERROR		= "Error";
var CONNECTING	= "Connecting";

// Backup Catalog Load options
var BACKUP_CATALOG_LOAD_BACKUPS = 1,
    BACKUP_CATALOG_LOAD_BACKUPS_COLD_COPIES = 2,
    BACKUP_CATALOG_LOAD_BACKUPS_COLD_HOT_COPIES = 4,
    BACKUP_CATALOG_LOAD_ALL = 7;

// Common hostname error message used by the protected asset dialogs.
var HOSTNAME_NON_WINDOWS_ERROR_MESSAGE = gettext("must be alphanumeric characters, '-', '_', or '.' and at most 31 characters");
var HOSTNAME_ERROR_MESSAGE = HOSTNAME_NON_WINDOWS_ERROR_MESSAGE + ", " + gettext("with at most 15 recommended if Windows.");

var TOUR_STEP_DASHBOARD_START = 1;
var TOUR_STEP_DASHBOARD_END = 6;
var TOUR_STEP_PROTECT_START = 7;
var TOUR_STEP_PROTECT_END = 10;
var TOUR_STEP_RECOVER_START = 11;
var TOUR_STEP_RECOVER_END = 14;
var TOUR_STEP_JOBS_START = 15;
var TOUR_STEP_JOBS_END = 19;
var TOUR_STEP_REPORTS_START = 20;
var TOUR_STEP_REPORTS_END = 21;
var TOUR_STEP_CONFIG_START = 22;
var TOUR_STEP_CONFIG_END = 24;

/*
 * KB Help Links
 */
var KB_URL = "https://support.unitrends.com/go/";

var DEFAULT_USER = 'root';
var DEFAULT_PW = 'unitrends1';

/*
 * Session Timeout error
 */
var SESSION_TIMEOUT_ERROR = gettext("Error: Your session has expired or is invalid.  Please log in again to continue.");

// Generic message for unknown error/no response for REST API.
var UNKNOWN_API_ERROR = 'A communications error occurred, and no response was received from the appliance.' + '<br/><br/>' +
    'This may be caused by a problem with the appliance or the browser.  Ensure that the appliance is running ' +
    'and retry this operation.  You may also need to close and re-open the browser if the failure persists.';

// Operating System Type (os type)
var OS_DOS            = 1;
var OS_WIN_16         = 2;
var OS_NT             = 3;
var OS_WINDOWS_95     = 4;
var OS_OS_2           = 5;
var OS_NOVELL         = 6;
var OS_UNIX3          = 7;
var OS_ODT            = 8;
var OS_OS5            = 9;
var OS_UNIX4          = 10;
var OS_SOLARIS        = 11;
var OS_SUN_OS         = 12;
var OS_NOVELL_4       = 13;
var OS_OSF1           = 14;
var OS_NT_SERVER      = 15;
var OS_AIX            = 16;  // Not Applicable in our Environment
var OS_SGI            = 17;
var OS_DGUX           = 18;
var OS_HP_UX          = 19;
var OS_LINUX          = 20;
var OS_BSDI           = 21;
var OS_USL            = 22;
var OS_UNIXWARE       = 23;
var OS_FREEBSD        = 24;
var OS_MACOS          = 25;
var OS_NOVELL_5       = 26;  // The API Guide lists this as just Novell, but there is already one Novell, so I am guessing this is Novell 5
var OS_Novell_6       = 27;
var OS_NOVELL_65      = 28;
var OS_WINDOWS_2000   = 29;
var OS_WINDOWS_XP     = 30;
var OS_WINDOWS_2003   = 31;
var OS_WINDOWS_VISTA  = 32;
var OS_IBMI5          = 33;
var OS_OES            = 34;
var OS_WINDOWS_2008   = 35;
var OS_WIN_2008_R2    = 36;
var OS_WINDOWS_7      = 37;
var OS_WINDOWS_8      = 38;
var OS_WINDOWS_2012   = 39;
var OS_GENERIC        = 40;
var OS_WINDOWS_8_1    = 41;
var OS_WINDOWS_2012_R2= 42;
var OS_WINDOWS_10     = 43;
var OS_WINDOWS_2016   = 44;

// Used when initializing an empty sid for backup catalog filters.
var DUMMY_URL_SID = "&sid=-1";
