/* Folliwing varible check the Host registration and Create Backup Job */
var resetTour = false;
var isJstreeBrowserDialog = false;
var loadArchivesErrorFlag  = false;
(function($, PHD, window, undefined) {

    var PHD = {
        DEBUG: false,
        App: {
            url: window.location.pathname,
            login: function() {
                window.location.href = PHD.App.url; // lmc - LOGIN_URL + "?next=" + PHD.App.url;
            },
            kbURL: function(id) {
                return KNOWLEDGE_BASE_URL + id;
            }
        },
	    // lmc - set at login.
        User: '',
        version: '',
        loading: {},
        connection: true,
        errors: $("#form-errors"),
        fetchedAlerts: false,
	    token: '',
        statsInterval: 20000,
        statsSyncInterval: 2500,

        dialogs: {
            wizard: {
                appendTo: "#dialogs",
                modal: true,
                show: {
                    effect: "drop",
                    duration: 400
                },
                hide: {
                    effect: "drop",
                    duration: 400
                },
                dialogClass: "dialog-wizard",
                draggable: false,
                resizable: false,
                position: {
                    my: "center center",
                    at: "center center"
                },
                open: function(event, ui) {
                    $("body")
                        .addClass("dialog-open")
                        .css("overflow", "auto");
                },
                close: function(event, ui) {
                    $("body")
                        .removeClass("dialog-open")
                        .css("overflow", "hidden");
                    $(this).wizard("destroy").remove();
                }
            },
            miniWizard: {
                modal: true,
                show: {
                    effect: "drop",
                    complete: function() {
                        $(document).trigger("miniwizardready", this);
                    }
                },
                hide: "drop",
                dialogClass: "dialog-wizard",
                draggable: false,
                resizable: false,
                width: 400,
                height: 500,
                position: {
                    my: "center",
                    at: "center"
                },
                open: function(event, ui) {
                    $(document)
                        .trigger("miniwizardopen", [event.target]);
                },
                close: function(event, ui) {
                    $(document)
                        .trigger("miniwizardclose", [event.target, "miniwizard-close"]);
                    $(this).dialog("destroy").remove();
                }
            },
            alert: {
                modal: true,
                draggable: false,
                resizable: false,
                width: 600,
                dialogClass: "dialog-notice",
                buttons: [
                    {
                        text: gettext("OK"),
                        click: function() {
                            $(this).dialog("destroy").remove();
							if (loadArchivesErrorFlag) {
							  PHD.currentDialog.wizard("close");
							 }
							  loadArchivesErrorFlag =false;
                        }
                    }
                ]
            },
            logout: {
                modal: true,
                draggable: false,
                resizable: false,
                width: 600,
                dialogClass: "dialog-notice",
                buttons: [
                    {
                        text: gettext("Logout"),
                        click: function() {
                            $(this).dialog("destroy").remove();
                            var e = $.Event("session-expired");
                            $(document).trigger(e);
                        }
                    }
                ]
            },
            auth: {
                modal: true,
                draggable: false,
                resizable: false,
                width: 600,
                dialogClass: "dialog-unauthenticated",
                buttons: {
                    "Dismiss": function() {
                        PHD.connection = true;
                        $(this).dialog("destroy").remove();
                    },
                    "Log In": function() {
                        PHD.App.login();
                    }
                }
            },
            errorDialog: {
                modal: true,
                draggable: false,
                resizable: false,
                width: 600,
                dialogClass: "dialog-error",
                buttons: {
                    "Dismiss": function() {
                        PHD.connection = true;
                        $(this).dialog("destroy").remove();
                    },
                    "Refresh": function() {
                        window.location.href=PHD.App.url;
                    }
                }
            },
            confirm: {
                modal: true,
                draggable: false,
                resizable: false,
                width: 600,
                dialogClass: "dialog-confirm",
                open: function(event, ui) {
                    $(event.target).next().find("button:last-child").focus();
                }
            },
            challenge: {
                modal: true,
                draggable: false,
                resizable: false,
                width: 300,
                height: 160,
                dialogClass: "dialog-challenge"
            }
        },

        windows: {},

        toggleLabel: function(delay) {
            var $input = $(this);
            if($input.val().length > 0) {
                $input.prev('span').css('visibility', 'hidden');
            }
            setTimeout(function() {
                if ( !$input.val() ) {
                    $input.prev('span').css('visibility', '');
                } else {
                    $input.prev('span').css('visibility', 'hidden');
                }
            }, delay || 0);
        },

        wizard: function(url, task, options, edit, onLoaded) {
            var w = 1256,//$(window).width() < 1180 ? 1180 : $(window).width() - 20,
                h = 768,//$(window).height() < 724 ? 724 : $(window).height() - 20,
                options = $.extend({ height: h, width: w }, this.dialogs.wizard, options),
                dialog = $("<div/>", { id: "dialog-" + task, "class": "dialog-box" });
            
            dialog.data("edit", edit || false);
            var onLoaded = onLoaded || null;

            PHD.Ajax
                .getHTMLWithLoader(url)
                .done(function(data) {
                    PHD.currentDialog = dialog;
                    dialog.hide()
                        .appendTo("body")
                        .html(data)
                        .wizard(options);
                    if (onLoaded != null) {
                        onLoaded();
                    }
                });

            return dialog;
        },

        miniWizard: function(url, task, options, edit, func) {
            var w = 400,
                h = 500,
                options = $.extend({ height: h, width: w }, this.dialogs.miniWizard, options),
                dialog = $("<div/>", { id: "dialog-" + task, "class": "dialog-box" });

            var func = func || null;

            dialog.data("edit", edit || false);
            $("body").css("overflow", "hidden");

            PHD.Ajax
                .getHTML(url)
                .done(function(data) {
                    PHD.currentMiniWizard = dialog;
                    dialog.hide()
                        .appendTo("body")
                        .html(data)
                        .dialog(options);
                    // lmc - allow passing of extra function
                    if (func != null) {
                        func(dialog);
                    }
                });

            return dialog;
        },

        confirmDialog: function(message, options, confirmText, confirmTip) {

            // Access the gettextCatalog service injected into the app.
            var elem = angular.element(document.querySelector('[ng-controller=GlobalCtrl]'));
            var injector = elem.injector();
            var gettextCatalog = injector.get('gettextCatalog');
            if (!_.isObject(gettextCatalog)) {
                gettextCatalog = { 'getString': function(item) { return item } };
            }

            var confirmText = confirmText || gettextCatalog.getString("Confirm");
            var confirmTip = confirmTip || null;
            var promise = $.Deferred(),
                buttons = [
                    {
                        text: confirmText,
                        title: confirmTip,
                        click: function() {
                            promise.resolve();
                            $(this).dialog("destroy").remove();
                        }
                    },
                    {
                        text: gettextCatalog.getString("Cancel"),
                        click: function() {
                            promise.reject();
                            $(this).dialog("destroy").remove();
                        }
                    }
                ];
            options.buttons = buttons;
            options = $.extend({}, this.dialogs.confirm, options);

            $("<div/>", {
                id: "dialog-confirm",
                "class": "dialog-box"
            })
            .hide()
            .appendTo("body")
            .html(message)
            .dialog(options);

            return promise;
        },

        challengeDialog: function(title) {
            var options = PHD.dialogs.challenge,
                promise = $.Deferred(),
                title = title || gettext("Please Authenticate to Continue"),
                form = PHD.Ajax.getHTML("/accounts/challenge/");

            form.done(function(data) {
                $("<div/>", {
                    id: "dialog-challenge",
                    title: title,
                    "class": "dialog-box"
                })
                .hide()
                .appendTo("body")
                .html(data)
                .dialog(options);
            });

            $(document).one("authchallengesuccess", function() {
                promise.resolve();
            });

            $(document).one("authchallengecancel", function() {
                promise.reject();
            });

            return promise;
        },

        ajaxError: function(jqXHR, textStatus, errorThrown) {
            var options = PHD.dialogs.alert,
                errorTitle = gettext('Error '),
                boxClass = 'scroll-box error',
                errorSummary, responseText,
                noconnection = false;

            if(jqXHR.status === 0) {
                if(jqXHR.state() === "rejected") return;
                if(errorThrown === 'timeout') {
                    errorSummary = gettext("Request timed out. Please check your network connection and ensure your PHD Virtual Backup Appliance is running properly and refresh the page.");
                    $(document).trigger("ajaxtimeout");
                } else {
                    errorSummary = gettext("Request aborted or undeliverable. Please check your network connection and ensure your PHD Virtual Backup Appliance is running properly and refresh the page.");
                    $(document).trigger("ajaxaborted");
                }
                errorTitle += jqXHR.status + " " + jqXHR.state();
                options = PHD.dialogs.errorDialog;
                noconnection = true;
            } else if(jqXHR.status === 401) {
                $(document).trigger("autherror");
                if(PHD.connection) {
                    PHD.connection = false;
                    PHD.throwAuthNotice({
                        result: [{
                            message: gettext("You must be logged in to do that.")
                        }]
                    });
                }
                return;
            } else if(jqXHR.status == 403 || jqXHR.status === 405 || jqXHR.status == 500) {
                PHD.throwError(jqXHR.responseJSON);
                return;
            } else if(jqXHR.status >= 400 && jqXHR.status < 500) {
                if(jqXHR.responseText) {
                    PHD.throwNotice({
                        result: [{
                            message: jqXHR.responseText
                        }]
                    });
                }
                return;
            } else {
                errorTitle += jqXHR.status + " " + textStatus;
                errorSummary = errorThrown;
                if(PHD.DEBUG && jqXHR.status === 500) {
                    options.height = 800;
                    boxClass += ' tall';
                }
            }

            responseText = '<div class="' + boxClass + '"><p>' + errorSummary + '</p>';

            if(jqXHR.responseText) {
                responseText += '<pre>' + jqXHR.responseText + '</pre>';
            }

            responseText += '</div>';
            if(PHD.connection) {
                $("<div/>", {
                    id: "dialog-ajax-error",
                    title: errorTitle,
                    "class": "dialog-box"
                })
                .hide()
                .appendTo("body")
                .html(responseText)
                .dialog(options);
                if(noconnection) {
                    PHD.connection = false;
                }
            }
        },

        alert: function(message) {
            var options = this.dialogs.alert,
                text = "<p>" + message + "</p>";

            $("<div/>", {
                id: "dialog-alert",
                title: gettext("Notice"),
                "class": "dialog-box"
            })
            .hide()
            .appendTo("body")
            .html(text)
            .dialog(options);
        },

        throwError: function(data) {
			if(isJstreeBrowserDialog == true){
				return;
			}	
            var options = this.dialogs.alert;
            var results;
            var response;
            var errorText;
            var unknownMessage = UNKNOWN_API_ERROR;

            // Access the gettextCatalog service injected into the app.
            var elem = angular.element(document.querySelector('[ng-controller=GlobalCtrl]'));
            var injector = elem.injector();
            var gettextCatalog = injector.get('gettextCatalog');

            if (data && data !== undefined && data.result !== undefined) {
                results = data.result;
                response = results.shift();
                if (response.message === undefined) {
                    response.message = unknownMessage;
                } else {
                    var message = response.message;
                    // call the 'logout' dialog in case of session expired.
                    if (message.indexOf(SESSION_TIMEOUT_ERROR) !== -1) {
                        response.message = gettextCatalog.getString(SESSION_TIMEOUT_ERROR);
                        options = this.dialogs.logout;
                        options.buttons[0].text = gettextCatalog.getString("Logout");
                    }
                    response.message = response.message.replace(/\n/g, "<br />");
                }
            } else {
                results = [];
                response = { 'message' : unknownMessage };
            }
            errorText = "<p>" + response.message + "</p>";
            if (results.length) {
                errorText += '<ul class="errorlist">';
                $.each(results, function(index, item) {
                    if(item.message !== null) {
                        errorText += "<li>" + item.message + "</li>";
                    }
                });
                errorText += '</ul>';
            }

            if (PHD.currentErrorDialog !== undefined && PHD.currentErrorDialog !== null && PHD.currentErrorDialog.is(':ui-dialog'))  {
                //console.log("error dialog");
                //console.log(PHD.currentErrorDialog);
                PHD.currentErrorDialog.remove();
                PHD.currentErrorDialog = null;
            }

            PHD.currentErrorDialog = $("<div/>", {
                id: "dialog-error",
                title: gettextCatalog.getString("Error"),
                "class": "dialog-box"
            })
            .hide()
            .appendTo("body")
            .html(errorText)
            .dialog(options);

        },

        throwNotice: function(data, options) {
            var results = data.result,
                response = results.shift(),
                responseText = "<p>" + response.message + "</p>";

            console.log("In throwNotice, message = " + responseText);

            // Access the gettextCatalog service injected into the app.
            var elem = angular.element(document.querySelector('[ng-controller=GlobalCtrl]'));
            var injector = elem.injector();
            var gettextCatalog = injector.get('gettextCatalog');

            options = options || {};
            if(options.hasOwnProperty("buttons") && _.isArray(options.buttons)) {
                options.buttons = PHD.util.extendArray(options.buttons, this.dialogs.alert.buttons);
            }
            options = $.extend(true, {}, this.dialogs.alert, options);

            if(results.length) {
                $.each(results, function(index, item) {
                    if(item.message !== null) {
                        responseText += "<p>" + item.message + "</p>";
                    }
                });
            }

            $("<div/>", {
                id: "dialog-notice",
                title: gettextCatalog.getString("Notice"),
                "class": "dialog-box"
            })
            .hide()
            .appendTo("body")
            .html(responseText)
            .dialog(options);
        },

        throwAuthNotice: function(data) {
            var options = this.dialogs.auth,
                results = data.result,
                response = results.shift(),
                responseText = "<p>" + response.message + "</p>";

            if(results.length) {
                $.each(results, function(index, item) {
                    if(item.message !== null) {
                        responseText += "<p>" + item.message + "</p>";
                    }
                });
            }

            $("<div/>", {
                id: "dialog-notice",
                title: gettext("User Authentication Error"),
                "class": "dialog-box"
            })
            .hide()
            .appendTo("body")
            .html(responseText)
            .dialog(options);
        },

        modalLoadTmpl: _.template(
            '<div class="loading-box">' + 
                '<h2><span>' +
                    '<i class="icon-restart icon-spin"></i> ' +
                    '<%= message %>' + 
                '</span></h2>' +
            '</div>'
        ),

        showLoadingIndicator: function(append, modal, message) {
            var modal = (modal === true),
                load = $("<span/>", {
                    "html": '<i class="icon-restart icon-spin"></i>',
                    "alt": gettext("Loading..."),
                    "class": "loading"
                }),
                hash = "";

            if(modal) {
                var $overlay = $("<div>", {
                    "class": "loading-overlay"
                });

                var boxHTML = PHD.modalLoadTmpl({"message": message}),
                    $box = $(boxHTML);

                $("body").append($box.hide()).append($overlay.focus());
                return $box.fadeIn().add($overlay);
            } else if(append.is("button")) {
                hash = "btn" + PHD.util.getNowHash(append.selector);
                PHD.loading[hash] = load.appendTo(append.addClass("btn-loading"));
            } else {
                hash = PHD.util.getNowHash(append.selector);
                PHD.loading[hash] = load.appendTo("body").position({
                    my: "center center",
                    at: "center center",
                    of: append
                });
            }

            return hash;
        },

        hideLoadingIndicator: function(obj) {
            if(void 0 === obj || obj == null) return;
            if(obj instanceof jQuery && obj.length) {
                obj.fadeOut(250, function() {
                    obj.remove();
                });
                return;
            }
            if (obj.indexOf("btn") === 0) {
                PHD.loading[obj].parent().removeClass("btn-loading");    
            }
            if (PHD.loading[obj] !== undefined) {
                PHD.loading[obj].remove();
            }
            delete PHD.loading[obj];
        },

        modalLoadingIndicator: function(message) {
            message = message || gettext("Loading...");
            return this.showLoadingIndicator(null, true, message);
        },

        util: {
            debounce: function(func, wait, immediate) {
                var timeout, result;
                return function() {
                    var context = this, args = arguments;
                    var later = function() {
                        timeout = null;
                        if (!immediate) result = func.apply(context, args);
                    };
                    var callNow = immediate && !timeout;
                    clearTimeout(timeout);
                    timeout = setTimeout(later, wait || 100);
                    if (callNow) result = func.apply(context, args);
                    return result;
                };
            },
            formatBytes: function(bytes) {
                var bytes = parseInt(bytes, 10);
                if(bytes <= 0 || isNaN(bytes)) {
                    return "0 GB";
                }

                var base = Math.log(bytes) / Math.log(1024),
                    unit = ['B', 'KB', 'MB', 'GB', 'TB' , 'PB' , 'EB'],
                    result = Math.pow(1024, base - Math.floor(base)),
                    precision = Math.round(result).toString().length === 1 ? 2 : 1;

                return result.toFixed(precision) + ' ' + unit[Math.floor(base)];
            },
            formatMB: function(MB) {
                var bytes = parseInt(MB, 10);
                if (bytes <= 0 || isNaN(bytes)) {
                    return "0 GB";
                }
                return this.formatBytes(bytes * 1048576);
            },
            formatGB: function(GB) {
                var bytes = parseInt(GB, 10);
                if (bytes <= 0 || isNaN(bytes)) {
                    return "0 GB";
                }
                return this.formatBytes(bytes * 1073741824);
            },
            sumArray: function(arr) {
                return arr.reduce(function(mem, val) { return mem + val; }, 0);
            },
            getHash: function() {
                var hash = window.location.hash;
                hash = hash.toString();
                var s = hash.substr(hash.lastIndexOf('#') + 1);
                //console.log("hash = " + hash + ' and s = ' + s);
                return s;
                //return hash.replace("#", "");
            },

            getHashInt: function() {
                return parseInt(this.getHash(), 10);
            },

            getNowHash: function(seed) {
                return "load" + seed.substring(0,4) + (new Date().getTime());
            },
            quoteattr: function(str) {
                return str
                    .replace(/&/g, '&amp;')
                    .replace(/'/g, '&apos;')
                    .replace(/"/g, '&quot;')
                    .replace(/</g, '&lt;')
                    .replace(/>/g, '&gt;');
            },
            getParams: function() {
                var ret = {},
                    qs; // lmc - not this, was window.location.search;

                // lmc - with AngularJS, URLs are "http://search/ui/#/<subsystem/..... and maybe #<hash>"
                var location = window.location.toString();
                var a = location.split("#/");
                // get url after subsystem.
                if (a.length == 2) {
                    var s = a[1];
                    a = s.split('?');
                    // get query parameters
                    if (a.length == 2) {
                        qs = a[1];
                        a = qs.split('#');
                        // remove hash
                        if (a.length == 2) {
                            qs = a[0];
                        }
                    }
                }
                //console.log('location = ' + window.location + ' and qs = ' + qs);
                
                if(qs) {
                    //lmc - no need for this.  ? is already gone due to split.
                    // qs = qs.substring(1).split("&");
                    qs = qs.split("&");
                    qs.forEach(function(query) {
                        var params = query.split("="),
                            key = params[0];

                        if(params.length === 1) {
                            params.push(true);
                        }
                        if(ret.hasOwnProperty(key)) {
                            if(_.isArray(ret[key])) {
                                ret[key].push(params[1]);
                            } else {
                                ret[key] = [ret[key], params[1]];
                            }
                        } else {
                            ret[key] = params[1];
                        }
                        
                    });
                    console.log('ret is ' + JSON.stringify(ret));
                    return ret;
                }
                return false;
            },
            extendArray: function() {
                if(arguments.length === 0) return [];
                if(arguments.length === 1) return arguments[0];
                var target = arguments[0],
                    sources = Array.prototype.slice.call(arguments, 1);

                sources.forEach(function(source) {
                    target = target.concat(source)
                });
                
                return target;
            },
            clamp: function(num, min, max) {
                if(num > max) return max;
                if(num < min) return min;
                return num;
            },
            isValidDate: window.isValidDate
        }
    };

    // lmc
    PHD.setInfo = function(name, token, version) {
	    PHD.User = name;
	    PHD.token = token;
	    PHD.version = version;
    };

    PHD.popOut = function(url, title, task, width, height) {
        var w = width || 600,
            h = height || 400,
            newWin = PHD.windows[task] = window.open(url, title,"height=" + h + ",width=" + w);
        if(window.focus) {
            newWin.focus();
        }
    };

    PHD.currentPage = {};

    $.ajaxSetup({
        cache: false,
        // lmc - set up error function depending on whether or not the user is passing in a custom error handler
        //error: PHD.ajaxError,
        beforeSend: function(xhr, settings) {
            // Add authentication token to header.
            xhr.setRequestHeader("AuthToken", global_user.token);
        }
    });

    PHD.Ajax = {
        active: {},
        send: function(type, url, data, dataType, loader, customHandler) {
            var self = this,
                phdXHR = $.Deferred(),
                hash = url+Date.now(),
                resp;

            // If a customHandler is provided, use it; otherwise, use the standard handler.
            $.ajaxSetup({
                error: customHandler !== false ? customHandler : PHD.ajaxError
            });

            // Set the proper content type for PUT/POST
            if (type == 'PUT' || type == 'POST') {
                resp = $.ajax({
                    type: type,
                    url: url,
                    contentType: 'application/json',
                    data: data
                });
            } else {
                resp = $.ajax({
                    type: type || 'GET',
                    url: url,
                    dataType: dataType || 'json',
                    data: data || ""
                });
            }
            this.active[hash] = resp;

            resp
                .done(function(data, textStatus, jqXHR) {
                    if(jqXHR.status === 401 ||
                                data.hasOwnProperty("result") &&
                                _.isArray(data.result) && data.result.length &&
                                data.result[0].code === AJAX_RESULT_UNAUTHENTICATED) {
                        PHD.throwAuthNotice(data);
                        phdXHR.reject(data, textStatus, jqXHR);
                    } else {
                        phdXHR.resolve(data, textStatus, jqXHR);
                    }
                })
                .always(function() {
                    PHD.hideLoadingIndicator(loader);
                    if(phdXHR.state() === "pending") {
                        phdXHR.reject();
                    }
                    delete self.active[hash];
                });

            return phdXHR;
        },
        session: function(key, value) {
	         // session variable use nvp?
            return this.send('POST',
		    '/recoveryconsole/bpl/nvp.php?auth=1:&type=save&format=json&name=root&nvptype=preferences&nvp='+key+'zxywz'+value);
            //return this.send('GET', '/session/set/'+key+"/"+value+"/");
        },
        get: function(url, loader, handler) {
            return this.send('GET', url, null, null, loader || null, handler || false);
        },
        getWithLoader: function(url, message) {
            return this.send('GET', url, null, null, PHD.modalLoadingIndicator(message));
        },
        getHTML: function(url) {
            return this.send('GET', url, "", "html");
        },
        getHTMLWithLoader: function(url, message) {
            return this.send('GET', url, "", "html", PHD.modalLoadingIndicator(message));
        },
        post: function(url, data, loader, handler) {
            return this.send('POST', url, data || null, "json", loader || null, handler || false);
        },
        delete: function(url, data, loader, handler) {
            return this.send('DELETE', url, data || null, "json", loader || null, handler || false);
        },
        put: function(url, data, loader, handler) {
            return this.send('PUT', url, data || null, "json", loader || null, handler || false);
        },
        delineateResponse: function(data) {
            var responses = [[],[],[],[]];
            $.each(data.result, function(index, item) {
                responses[item.code].push(item);
            });
            return responses;
        },
        safeabort: function() {
            _.each(this.active, function(xhr) {
                xhr.abort();
            });
        }
    };

    PHD.DOMReady = function(context) {
        var context = context || document;

        $("#hide-the-page-so-ted-is-happy").remove();

        // Fancy text inputs need their fancy labels toggled
        if($('.control-group.fancy input', context).length) {
            $('.control-group.fancy input', context).each(function() { PHD.toggleLabel.call(this, 20); });
            $('.control-group.fancy', context).on("click", "span", function() {
                $(this).next().focus();
            });
        }
        // Let help trigger in labels recieve their own click event
        if($('label .help-trigger', context).length) {
            $('label', context).on("click", ".help-trigger", function(e) { e.preventDefault(); /*$(this).trigger("popover")*/ });
        }
    };

    PHD.updateAlerts = function(force, alert_count) {
        console.log('in update alerts, count is = ' + alert_count);
        //lmc todo, not getting called?
        if(force === true || !this.fetchedAlerts) {
          // $(".alert-count").text(data.count).toggleClass("critical", (data.count == 0));
            //$("#app-header .alert-count").text(alert_count);
            self.fetchedAlerts = true;
        }
    };

    PHD.fetchStats = function() {
		// Don't call the API if in the wizard.
        var scope = angular.element(document).scope();
        if (scope == undefined || scope.user.showSetupWizFlag || scope.maintenance_mode) {
            console.log("fetchStats(): in Wizard, not calling summary/current");
            PHD.statsTimeout = setTimeout(PHD.fetchStats, PHD.statsInterval);
        } else {
            var url = "/api/summary/current/?lang=" + scope.userLanguageCode;
            PHD.Ajax.get(url).done(PHD.updateStats);
        }
    };

    PHD.updateStats = function(data) {
        clearTimeout(PHD.statsTimeout);
        //$("#app-header .alert-count").text(data.alert_count).toggleClass("critical", (data.alert_count > 0));
        var message = data.sync_last || "Never";
        if (data.message) {
            message += ", " + data.message;
        }
        $("#app-header .inventory-sync-last-run").text(message);
        $("#app-header .btn-inventory-sync").toggleClass("disabled", data.sync_running);
        $("#app-header .inventory-sync-running").toggleClass("hidden", !data.sync_running);
        if(data.sync_running) {
            $("#app-header .inventory-sync-running .percentage").text("(" + data.sync_progress + "%)");
        }
        PHD.globalAlertCounts = { 'alert_count': data.alert_count, 'max_severity': data.max_severity, 'at_risk_alert': data.at_risk_alert, 'timestamp': data.timestamp };
	    // lmc increase frequency if a sync is running.
        PHD.statsTimeout = setTimeout(PHD.fetchStats, data.sync_running ? PHD.statsSyncInterval : PHD.statsInterval);
    };

    $(".btn-inventory-sync").on("click", function(event) {
        event.preventDefault();
        $("#app-header .inventory-sync-running .percentage").text("");
	    // the rest is done in AngularJS, in options.js.
    });

    $(window).on("login", function (event) {
        console.log("=====>On Login: set Info: name = " + event.name + " and version = " + event.version);
        PHD.setInfo(event.name, event.token, event.version);
    });

    // Native JS Object extensions
    if(typeof String.prototype.startsWith !== 'function') {
        String.prototype.startsWith = function(prefix) {
            return this.indexOf(prefix) == 0;
        };
    }

    if(typeof String.prototype.endsWith !== 'function') {
        String.prototype.endsWith = function(suffix) {
            return this.indexOf(suffix, this.length - suffix.length) !== -1;
        };
    }

    window.PHD = PHD;

})(jQuery, window.PHD || (window.PHD = {}), window);
