angular.module('RecoverTileModule',['dynamicdashboardapp','ui.dashboard'])
.controller('RecoverTileContorller', function ($scope,$rootScope, $http, $timeout, gettextCatalog){
    console.log('RecoverTileContorller');
    $scope.daysArray=["7/30","7/31","8/1","8/2","8/3","8/4","8/5"];
    $scope.maxValueArray=[];
    $scope.maxvalue=6;
    $scope.maxValuewithUnits="6 GB/s";
    $scope.dataValues=[[0,0,0,0,0,0,0]];
    $scope.units="GB/s";
    $scope.colorArray =["rgb(40,155,212)"];
    $scope.legends=[
        gettextCatalog.getString("Avg Speed")
    ];
    $scope.reSizeGraph=true;
    $scope.refreshKey="dash_backup_refresh";
    $scope.widgetName="Recover Summary";
    /* Click Event Listener for open configure model dialog box  */
    $scope.modalShown=false;
    $scope.toggleModal=function(){
	        $scope.modalShown=!$scope.modalShown;
    };

    /* Event listener for dialogopenEvent */
    $scope.$on('dialogopenEvent', function (event, widget,index){
        if(widget.name === 'RECOVER SUMMARY'){
            $scope.toggleModal();
            $("[id='id_recover summaryRefresh']").val($rootScope.listOfTimer[7]/1000);
		//	$('#id_backupRefresh').val($rootScope.listOfTimer[7]/1000);
			event.defaultPrevented = true;
        }
    });
	/* Event listener for manual;Refesh */
	$scope.$on('manualRefreshEvent', function (event, widget,index){
     if(widget.name === 'RECOVER SUMMARY'){
		$rootScope.getRecoverRefereshData();
		event.defaultPrevented = true;
       
        }
    });

    /* Event listener for leaving the widget */
    $scope.$on('leaveWidget', function (event, widget,index){
        if(widget.name === 'RECOVER SUMMARY'){
            if ($scope.modalShown) {
                $scope.modalShown = false;
                $timeout(function() {
                    $scope.$digest();
                });
            }
        }
    });

	$scope.userPrefernce = function(){
           $rootScope.manualRefreshControl($rootScope.listOfTimer[7]/1000,$scope.widgetName);
    }
    $scope.runReport = function(index){
        if (index === 14) {
            var days = 6;
            var sid = $rootScope.local.id;
            location.href = "#/reports/" + index + '/' + days + '/' + sid;
        } else if (index === 1) {
            window.location.href = "#/recover/";
            setTimeout(function () {
                $("#fileLevelRecover a").trigger('click');
            }, 1000);
        } else if (index === 2) {
            window.location.href = "#/recover/";
            setTimeout(function () {
                $("#instantRecovery a").trigger('click');
            }, 1000);
        } else if (index === 3) {
            window.location.href = "#/recover/";
            setTimeout(function () {
                $("#replicas a").trigger('click');
            }, 1000);
        }
    };
    $scope.getRestoreData=function(){
         var url="/api/summary/counts";
         $http({
                url: url, 
                method: "GET"
        }).success(function(data, status, headers){
                //var timestamp=data.timestamp *1000;
                $scope.timeStamp = data.last_updated;//getDateString(timestamp);
                $scope.recentRestores=data.restore_recent;
                $scope.activeIR=data.restore_active_ir;
                $scope.activeFLR=data.restore_active_flr;
                $scope.activeReplicas=data.wir_protected + data.replica_protected;
        });   
    }
    $scope.averageRecoverySpeeds=function(){
       /*var url="app/dynamic-dashboard/recovery/recover.json";*/
        var url='/api/summary/days/restore';
       $http({
            url: url, 
            method: "GET"
        }).success(function(data, status, headers){
           var avgSpeedArray=data.data[0].restore_speed;
           var dataArray=[];
           var daysArray=[];
           for (var i =0 ; i < avgSpeedArray.length; i++){
               if (i == 0){
                   $scope.units=avgSpeedArray[i].units;
               }
               dataArray[i]=avgSpeedArray[i].avg_speed;
               daysArray[i] = dateAxisLabel(avgSpeedArray[i].day, true);
		  }
          $scope.dataValues=[dataArray];
          $scope.daysArray=daysArray;
          $scope.maxvalue=Math.max.apply(Math,dataArray);
          $scope.maxValuewithUnits=$scope.maxvalue+$scope.units;
          var avgspeed_width = $('#recover-graph-avgspeed').width();
          if (avgspeed_width !== null) {
              $('#recover-graph-avgspeed').empty();
              var raph_avgspeed=Raphael('recover-graph-avgspeed',"100%","100%");
              plotBarGraph_BackupWidget(raph_avgspeed, $scope.dataValues, $scope.units,$scope.daysArray,$scope.colorArray, $scope.legends, $scope.maxValuewithUnits,$scope.maxvalue,avgspeed_width);
          }
        });
    }
    $rootScope.getRecoverRefereshData = function(){
        $scope.getRestoreData();
    }
    if ($scope.user.loggedIn) {
	       $scope.getRestoreData();
           $scope.userPrefernce();
           $scope.averageRecoverySpeeds();
    }
    var handleResize = function(event) {
        if ($scope.reSizeGraph == true){
            var avgspeed_width = $('#recover-graph-avgspeed').width();
            $('#recover-graph-avgspeed').empty();
            var raph_avgspeed=Raphael('recover-graph-avgspeed',"100%","100%");
            plotBarGraph_BackupWidget(raph_avgspeed, $scope.dataValues, $scope.units,$scope.daysArray,$scope.colorArray,     $scope.legends, $scope.maxValuewithUnits,$scope.maxvalue,avgspeed_width);
        }
    };
    $(window).on("resize", handleResize);
    $scope.$on("languageChanged", function (event){
        if ($scope.reSizeGraph === true) {
            $scope.legends=[
                gettextCatalog.getString("Avg Speed")
            ];
            $scope.averageRecoverySpeeds();
        }
    });
    $(document)
        .on("login", stopAll)
        .on("logout", stopAll)
        .on("uinav.protect", stopAll)
        .on("uinav.recover", stopAll)
        .on("uinav.jobs", stopAll)
        .on("uinav.configure", stopAll)
        .on("uinav.reports", stopAll);

     function stopAll() {
         clearInterval($rootScope.listOfTimerFunction[7]);
         $scope.reSizeGraph=false;
         $(document).off("uinav.protect", stopAll);
         $(document).off("uinav.recover", stopAll);
         $(document).off("uinav.jobs", stopAll);
         $(document).off("uinav.configure", stopAll);
         $(document).off("uinav.reports", stopAll);
         $(document).off("login", stopAll);
         $(document).off("logout", stopAll);
	}
     
});