angular.module('backupJobModule', ['ngDialog', 'angulartics', 'angulartics.google.analytics','ui.grid','ui.grid.resizeColumns','ui.grid.autoResize','fileBrowserDialogApp','ngGrid','ui.bootstrap'])
.config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
		  });
}])
.factory('sharedGridData', function(){
            return {
                    excludeListArray:[],
                    includeListArray:[],
                    tempArray:[],
                    inclusionData:[],
                    exclusionData:[],
                    directoryId:'',
                    currentTab:1,
				    protectionRulesArray:[]
            };
})
.controller('backupJobCtrl', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics','fileBrowserDialogService','sharedGridData','$protectService',
        function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,fileBrowserDialogService,sharedGridData,$protectService) {
/*Start Dummy code to be replaced by Saurabh's code */             
            $scope.inventoryGridOptions = {};
            $scope.assetType={};
            $scope.assetTypeList=[
            { name: "Server", hypervisor:"0" ,id:"PHYSICALSERVER"},
			{ name: "VMware", hypervisor:"3" ,id:"VMware"},  
            { name: "HyperV", hypervisor:"4" ,id:"HyperV"},
			{ name: "NAS",    hypervisor:"0"    ,id:"NAS"}
        ];
        $scope.setAssetType=function(){
            if($rootScope.isSelectedJobFileLevel){
                 $scope.assetType.id= $scope.assetTypeList[0].id;
            }else if($rootScope.isSelectedJobNAS){
                 $scope.assetType.id= $scope.assetTypeList[3].id;
            }else{
                 $scope.assetType.id= $scope.assetTypeList[3];
            }
        }
        $scope.filterInventory = function(){
            $rootScope.treeData=[];
            $protectService.loadTreeData($http,$scope,$rootScope,$scope.assetType.id,false);
        };
        if(!$scope.isEdit){
             $rootScope.treeData=[];
         }
        $scope.nextWizard = function($event){
            if(wizardTitle == "Select Items"){  
                $rootScope.$broadcast("nextBtnClick");   
                   
            }
        }

/*End of Dummy code to be replaced by Saurabh's code */
}]);