/*
    These are the codes for the context-sensitive help links, as provided by documentation.
    To create a link to an HTML topic, use the numeric CSH identifier. Example link:
    http://www.unitrends.com/documents/rs-ueb-admin-guide/Default.htm#cshid=1306
*/

var DOC_ABOUT_GUIDE = 1227,
    DOC_ADD_DISK = 1228,
    DOC_ADD_EXTERNAL_STORAGE = 1229,
    DOC_ADD_STORAGE_TO_UEB = 1230,
    DOC_ALERT_REPORT = 1231,
    DOC_APPLIANCE_REPORTS = 1232,
    DOC_APPLIANCE_SETTINGS = 1233,
    DOC_APPLICATION_BACKUPS_OVERVIEW = 1235,
    DOC_ASSET_LEVEL_BACKUPS_OVERVIEW = 1236,
    DOC_BACKUPS_HELP = 1237,
    DOC_BACKUP_ADMIN_AND_PROCEDURES = 1238,
    DOC_BACKUP_COPIES = 1239,
    DOC_BACKUP_COPIES_PAST24_REPORT = 1240,
    DOC_BACKUP_COPY_CAPACITY_REPORT = 1241,
    DOC_BACKUP_COPY_COLD_TARGETS_REPORT = 1242,
    DOC_BACKUP_COPY_HOT_TARGETS_REPORT = 1243,
    DOC_BACKUP_COPY_REPORTS = 1244,
    DOC_BACKUP_COPY_TARGETS = 1245,
    DOC_BACKUP_FAILURES = 1246,
    DOC_BACKUP_HISTORY_REPORTS = 1247,
    DOC_BACKUP_REPORTS = 1248,
    DOC_BACKUP_STORAGE = 1249,
    DOC_CAPACITY_REPORT = 1250,
    DOC_CISCO_UCS_SERVICE_PROFILE_BACKUP_REQS = 1251,
    DOC_CITRIX_XENSERVER_VMS = 1252,
    DOC_CONFIGURATION = 1253,
    DOC_CONFIGURE_TAB = 1254,
    DOC_CONSIDERATIONS_FOR_ASSET_LEVEL_BACKUPS = 1255,
    DOC_COPIED_ASSETS = 1256,
    DOC_CREATING_BACKUP_COPY_JOBS = 1257,
    DOC_CREATING_BACKUP_JOBS = 1000,
    DOC_CUSTOM_FOLDERS = 1259,
    DOC_DASHBOARD = 1260,
    DOC_DATA_PROTECTION_BEST_PRACTICES = 1261,
    DOC_DATA_REDUCTION_REPORT = 1262,
    DOC_DELETING_BACKUPS_AND_BACKUP_COPIES = 1263,
    DOC_EXCHANGE_BACKUP_REQUIREMENTS_AND_CONSIDERATIONS = 1267,
    DOC_GLOBAL_OPTIONS_TOOLBAR = 1268,
    DOC_HOST_LEVEL_BACKUPS_OVERVIEW = 1269,
    DOC_HYPER_V_VIRTUAL_MACHINES = 1270,
    DOC_INSTALLING_THE_AIX_AGENT = 1271,
    DOC_INSTALLING_THE_HP_UX_AGENT = 1272,
    DOC_INSTALLING_THE_LINUX_AGENT = 1273,
    DOC_INSTALLING_THE_MAC_AGENT = 1274,
    DOC_INSTALLING_THE_NOVELL_NETWARE_AGENT = 1275,
    DOC_INSTALLING_THE_NOVELL_OES_LINUX_AGENT = 1276,
    DOC_INSTALLING_THE_SCO_OPENSERVER_AGENT = 1277,
    DOC_INSTALLING_THE_SOLARIS_AGENT = 1278,
    DOC_INSTALLING_THE_UNIXWARE_AGENT = 1279,
    DOC_INSTALLING_THE_WINDOWS_AGENT = 1280,
    DOC_INTRODUCTION_TO_RS_UEB = 1281,
    DOC_ISERIES_BACKUPS_OVERVIEW = 1282,
    DOC_JOBS_TAB = 1283,
    DOC_LEGAL_HOLD_BACKUPS_REPORT = 1284,
    DOC_LOAD_REPORT = 1285,
    DOC_MANAGING_ACTIVE_JOBS = 1286,
    DOC_MANAGING_APPLIANCES = 1287,
    DOC_MANAGING_BACKUP_COPY_TARGETS = 1288,
    DOC_MANAGING_PROTECTED_ASSETS = 1289,
    DOC_MANAGING_SCHEDULED_JOBS = 1290,
    DOC_NAS_BACKUPS_OVERVIEW = 1291,
    DOC_NAVIGATING = 1292,
    DOC_ORACLE_BACKUP_REQUIREMENTS_AND_CONSIDERATIONS = 1294,
    DOC_PERFORMING_INSTANT_RECOVERY_ = 1295,
    DOC_PREPARING_FOR_INSTANT_RECOVERY = 1296,
    DOC_PROTECTED_ASSETS = 1298,
    DOC_PROTECTING_HYPER_V_VIRTUAL_MAC = 1299,
    DOC_PROTECTING_VMWARE_VIRTUAL_MAC = 1300,
    DOC_PROTECTION_OVERVIEW = 1301,
    DOC_PROTECTION_SUMMARY_REPORT = 1302,
    DOC_PROTECT_TAB = 1303,
    DOC_RECOVERING_APPLICATION_BACKUPS = 1304,
    DOC_RECOVERING_ASSET_LEVEL_BACKUPS = 1305,
    DOC_RECOVERING_A_VIRTUAL_MACHINE = 1306,
    DOC_RECOVERING_BACKUP_COPIES = 1307,
    DOC_RECOVERING_CISCO_UCS_SERVICE_PROFILE_BACKUPS = 1308,
    DOC_RECOVERING_EXCHANGE_BACKUPS = 1309,
    DOC_RECOVERING_FILES_FROM_VIRTUAL_ = 1310,
    DOC_RECOVERING_HOST_LEVEL_BACKUPS = 1311,
    DOC_RECOVERING_ISERIES_BACKUPS = 1312,
    DOC_RECOVERING_NAS_BACKUPS = 1313,
    DOC_RECOVERING_ORACLE_BACKUPS = 1314,
    DOC_RECOVERING_SHAREPOINT_BACKUPS = 1315,
    DOC_RECOVERING_SQL_BACKUPS = 1316,
    DOC_RECOVERY_HELP = 1317,
    DOC_RECOVERY_ASSURANCE_HELP = 1002,
    DOC_RECOVERY_HISTORY_REPORT = 1318,
    DOC_RECOVERY_OVERVIEW = 1319,
    DOC_RECOVER_REPORTS = 1320,
    DOC_RECOVER_TAB = 1321,
    DOC_REMOVING_THE_AIX_AGENT = 1322,
    DOC_REMOVING_THE_HP_UX_AGENT = 1323,
    DOC_REMOVING_THE_LINUX_AGENT = 1324,
    DOC_REMOVING_THE_MAC_AGENT = 1325,
    DOC_REMOVING_THE_NOVELL_NETWARE_AGENT = 1326,
    DOC_REMOVING_THE_NOVELL_OES_LINUX_AGENT = 1327,
    DOC_REMOVING_THE_SCO_OPENSERVER_AGENT = 1328,
    DOC_REMOVING_THE_SOLARIS_AGENT = 1329,
    DOC_REMOVING_THE_UNIXWARE_AGENT = 1330,
    DOC_REPORTS = 1331,
    DOC_REPORTS_TAB = 1332,
    DOC_SELECTING_HYPER_V_VMS_TO_PROTECT = 1334,
    DOC_SETTING_UP_A_VIRTUAL_FAILOVER_CLIENT = 1335,
    DOC_SHAREPOINT_BACKUP_REQUIREMENTS_AND_CONSIDERATIONS = 1336,
    DOC_SQL_BACKUP_REQUIREMENTS_AND_CONSIDERATIONS = 1338,
    DOC_STORAGE_FOOTPRINT_REPORT = 1339,
    DOC_STORAGE_REPORTS = 1340,
    DOC_STORAGE_REPORT_ = 1341,
    DOC_STORAGE_SPACE_AND_BACKUP_RETEN = 1342,
    DOC_SUPPORT_FOR_RECOVERY_SERIES_AND = 1343,
    DOC_TEARING_DOWN_THE_RECOVERY_OBJECT = 1344,
    DOC_TYPES_OF_DATA_PROTECTED = 1346,
    DOC_TYPES_OF_REPORTS = 1347,
    DOC_UPDATE_HISTORY_REPORT = 1348,
    DOC_UPDATING_THE_WINDOWS_AGENT = 1349,
    DOC_VIEWING_A_FILE_RECOVERY_OBJECT = 1351,
    DOC_VIEWING_RECENT_JOBS = 1352,
    DOC_VIEWING_SYSTEM_JOBS = 1353,
    DOC_VIRTUAL_MACHINE_INSTANT_RECOVERY = 1354,
    DOC_VMWARE_VIRTUAL_MACHINES = 1358,
    DOC_WINDOWS_INSTANT_RECOVERY = 1359,
    DOC_WINDOWS_INSTANT_RECOVERY_OVERVIEW = 1360,
    DOC_WINDOWS_INSTANT_RECOVERY_REQUIREMENTS_AND_PREREQUISITES = 1361,
    DOC_WINDOWS_INSTANT_RECOVER_ADMINISTRATION_PROCEDURES = 1362,
    DOC_WORKING_WITH_HYPER_V_SERVERS = 1363,
    DOC_WORKING_WITH_REPORTS = 1364,
    DOC_CONFIGURING_PSA_SETTINGS_IN_TH = 1373,
    DOC_CONFIGURING_SETTINGS_IN_CONNEC = 1374,
    DOC_CONFIGURING_THE_PSA_TOOL = 1375,
    DOC_CONFIGURING_THE_UNITRENDS_PSA_ = 1376,
    DOC_EDITING_OR_REMOVING_A_PSA_CO = 1377,
    DOC_INTRODUCTION2 = 1378,
    DOC_NOTIFICATIONS_REPORT = 1379,
    DOC_PSA_INTEGRATION_WITH_CONNECTWI = 1380,
    DOC_TRAP_HISTORY_REPORT = 1381,
    DOC_USING_THE_BILLINGINVOKER_SCRIPT = 1382,
    DOC_VIEWING_TICKET_HISTORY = 1383,
    DOC_WEEKLY_STATUS_REPORT = 1384,
    DOC_UNITRENDS_AGENTS = 1001,
    DOC_APPLIANCE_DISASTER_RECOVERY = 1399,
    DOC_IMPLEMENTING_IMAGE_BASED_BARE_METAL_PROTECTION = 1406,
    DOC_IMPLEMENTING_WINDOWS_INTEGRATED_BARE_METAL = 1408,
    DOC_PERFORMING_IMAGE_BASED_BARE_METAL_RECOVERY = 1411,
    DOC_PERFORMING_THE_INTEGRATED_BARE_METAL_RECOVERY = 1413,
    DOC_WINDOWS_HOT_BARE_METAL_PROTECTION = 1423,
    DOC_WINDOWS_IMAGE_BASED_BARE_METAL_RECOVERY = 1424,
    DOC_WINDOWS_INTEGRATED_BARE_METAL_RECOVERY = 1425,
    DOC_RECOVERY_ASSURANCE = 1002,
    DOC_ACCESSING_THE_APPLIANCE_FROM_THE_COMMAND_LINE_INTERFACE = 1438,
    DOC_APPLICATION_TESTS_AND_CUSTOM_SCRIPTS = 1439,
    DOC_BARE_METAL_FOR_LINUX = 1440,
    DOC_BARE_METAL_PROTECTION_AND_RECOVERY = 1441,
    DOC_COMPLIANCE__REPORTS = 1442,
    DOC_COMPLIANCE_REPORT = 1443,
    DOC_COPY_DATA_MANAGEMENT_OVERVIEW = 1444,
    DOC_COPY_DATA_MANAGEMENT_REQUIREMENTS_AND_CONSIDERATIONS = 1445,
    DOC_CREATING_SLA_POLICIES = 1446,
    DOC_CUSTOM_SCRIPTS = 1447,
    DOC_FAILOVER = 1448,
    DOC_IMPLEMENTING_LINUX_HOT_BARE_METAL_PROTECTION = 1449,
    DOC_LINUX_COLD_BARE_METAL_PROTECTION = 1450,
    DOC_LINUX_HOT_BMR = 1451,
    DOC_MANAGING_SLA_POLICIES = 1452,
    DOC_PERFORMING_LINUX_HOT_BMR = 1453,
    DOC_PROFILES = 1454,
    DOC_RECOVERY_ASSURANCE_REPORT = 1455,
    DOC_REQUIREMENTS_FOR_WINDOWS_ASSET_LEVEL_BACKUPS = 1456,
    DOC_RUNNING_DATA_COPY_ACCESS_JOBS = 1457,
    DOC_RUN_TEST = 1458,
    DOC_START_LAB = 1459,
    DOC_VIEWING_APPLIANCES = 1460,
    DOC_WORKING_WITH_DATA_COPY_ACCESS_JOBS = 1461,
    DOC_APPLIANCE_MANAGEMENT_PROCEDURES = 1467,
    DOC_APPLICATION_TESTS = 1468,
    DOC_PROTECTION_POLICIES_REPORT = 1469,
    DOC_REPLICAS_REPORT = 1470,
    DOC_SETTING_UP_A_VM_REPLICA = 1471,
    DOC_VM_REPLICAS = 1472,
    DOC_VM_REPLICA_REQUIREMENTS = 1473,
    DOC_WORKING_WITH_VM_REPLICAS = 1474,
    DOC_APPLIANCE_MANAGEMENT_REQUIREMENTS_AND_CONSIDERATIONS = 1477,
    DOC_EMAIL_REPORTS = 1478,
    DOC_FAILURE_REPORT = 1479,
    DOC_LOGGING_IN_TO_THE_UI = 1480,
    DOC_MANAGEMENT_STATUS_REPORT = 1481,
    DOC_REPLICATION_ACTIVITY_REPORT = 1482,
    DOC_REPORTING_FOR_MANAGERS = 1483,
    DOC_REQUIREMENTS_FOR_WINDOWS_ASSET_LEVEL_BACKUPS1 = 1484,
    DOC_SCHEDULE_REPORT = 1485,
    DOC_SECURESYNC_REPORT = 1486,
    DOC_SYSTEM_STATUS_REPORT = 1487,
    DOC_WORKING_WITH_COLD_COPIES = 1488;

